<?php
namespace App\Controller;

use App\Controller\AppController;
use cake\ORM\TableRegistry;
use Cake\I18n\Time;
use Cake\Event\Event;
use Cake\Core\Configure;

/**
 * Items Controller
 *
 * @property \App\Model\Table\ItemsTable $Items and AutoSparePartsTable $AutoSpareParts
 */
class ContentsController extends AppController {
    public function initialize() {
        parent::initialize();        
       
    }

	public function beforeRender(Event $event) {
        parent::beforeRender($event);

    }

    public function isAuthorized($user) {
        $action = $this->request->params['action'];

        return true;
    }

    /**
     * Index method
     *
     * @return void
     */
	public function index() {
		$pageTitle = 'All Contents';
		
		// Retrieve the active menu from the slug
		$mc = $this->Menus->find('all')->where(['Menus.slug'=>$this->slug])->first();
		
		$listings = $this->PageContents->find('All')
									   	->contain([
											'Contents.ContentImages', 'Menus.ParentMenus'
										])
										->where([
											'OR' => [
												['Menus.id'=>$mc->id],
												['Menus.parent_menu_id'=>$mc->id],
												['ParentMenus.parent_menu_id'=>$mc->id]
											]
										])
										->order([
											'Menus.name' => 'ASC',
											'Contents.name' => 'ASC'
										]);
		
		$listings = $this->paginate($listings);
		
		$this->set(compact('pageTitle', 'listings'));
    }

	public function add($id=null) {
    	$images=[];
    	$tagId="";
        $parentMenus = $this->Menus->find('all')->where(['parent_menu_id'=>$id])->combine('id','name');
        $content = $this->Contents->newEntity();

        if ($this->request->is(['post'])) {
           	if(!empty($this->request->data['sbsbsbmenu_id'])){
           		$this->request->data['menu_id']=$this->request->data['sbsbsbmenu_id'];
			
			}elseif(!empty($this->request->data['sbsbmenu_id'])){
           		$this->request->data['menu_id']=$this->request->data['sbsbmenu_id'];
			
			}elseif(!empty($this->request->data['sbmenu_id'])){
            	$this->request->data['menu_id']=$this->request->data['sbmenu_id'];
           
			}else{
            	$this->request->data['menu_id']=$this->request->data['pmenu_id'];
			}

			$content = $this->Contents->patchEntity($content, $this->request->data);
			
            if ($this->Contents->save($content)) {

                $pagecontent = $this->PageContents->newEntity(); 
               
                $this->request->data["content_id"] = $content->id;
				$pc=$this->PageContents->find('All')->where(["menu_id"=> $this->request->data["menu_id"],"content_id"=>$this->request->data["content_id"]]);
				
                if(empty($pc->toArray())){
                   	$pagecontent = $this->PageContents->patchEntity($pagecontent, $this->request->data);
                    $this->PageContents->save($pagecontent);
                }

				$images = [];
				for($i = 1; $i < 6; $i++) {
				   	$image_field = 'image' . $i;
					
				   	if(isset($this->request->data[$image_field])){
						$imageinfo = $this->request->data[$image_field]['tmp_name'] != null ? getimagesize($this->request->data[$image_field]['tmp_name']) : 'temp';
						$fileOK = $this->uploadFiles(Configure::read('IMAGE_PREPATH'), $this->request->data[$image_field]);

						if(array_key_exists('urls', $fileOK)) {  							
							$image = $this->ContentImages->newEntity([
								'image_path' => substr($fileOK['file_path'][0], Configure::read('IMAGE_PRELENGTH'), strlen($fileOK['file_path'][0])),
								'content_id' => $content->id
							]);
							$image = $this->ContentImages->patchEntity($image, $this->request->data);
							array_push($images, $image);
						}
					}
				}
				
				if(sizeof($images > 0)) {
					$this->ContentImages->saveMany($images);
				}
				
                $pagecontent = $this->PageContents->newEntity(); 

				//  $this->request->data["menu_id"]=$section->id;
                $this->request->data["content_id"]=$content->id;
                $pc=$this->PageContents->find('All')->where(["menu_id"=> $this->request->data["menu_id"],"content_id"=>$this->request->data["content_id"]]);
                
				if(empty($pc->toArray())){
					$pagecontent = $this->PageContents->patchEntity($pagecontent, $this->request->data);
                    $this->PageContents->save($pagecontent);
                }
				
                $this->Flash->success(__('Content added successfully.'));
                return $this->redirect(['controller' =>  isset($this->request->params['section']) ? 
																$this->request->params['section'] : $this->request->params['controller'], 
										'action' => 'pendingListings']);
            } else {
                $this->Flash->error(__('The row could not be save. Try again'));
				
            }
        }     
		
        $menu_id=$id;   
        $this->set(compact('pageTitle','parentMenus','content','images','menu_id'));
	}

	public function edit($id=null, $cid=null, $pcid=null) {

		$parentMenus = $this->Menus->find('all')->where(['parent_menu_id'=>$id])->combine('id','name');
        $content = $this->Contents->get($cid);      
		$images = $this->ContentImages->find('All')->where(['content_id'=>$cid]);
		$subMenus = [];
		$content_sub_sub_menu_id = null;
		$content_sub_menu_id = null;
		
		if ($this->request->is(['post', 'put', 'patch'])) {
			$this->request->data['status']=2; 
			$this->request->data["content_id"]=$content->id;
			
			$content = $this->Contents->patchEntity($content, $this->request->data);
            
			if ($this->Contents->save($content)) {
				$images = [];
				for($i = 1; $i < 6; $i++) {
				   	$image_field = 'image' . $i;
					
				   	if(isset($this->request->data[$image_field])){
						$imageinfo = $this->request->data[$image_field]['tmp_name'] != null ? getimagesize($this->request->data[$image_field]['tmp_name']) : 'temp';
						$fileOK = $this->uploadFiles(Configure::read('IMAGE_PREPATH'), $this->request->data[$image_field]);
					   	
						if(array_key_exists('urls', $fileOK)) {
							$image = $this->ContentImages->newEntity([
								'image_path' => substr($fileOK['file_path'][0], Configure::read('IMAGE_PRELENGTH'), strlen($fileOK['file_path'][0])),
								'content_id' => $content->id
							]);
							$image = $this->ContentImages->patchEntity($image, $this->request->data);
							array_push($images, $image);
						}
					}
				}
				
				if(sizeof($images > 0)) {
					$this->ContentImages->saveMany($images);
				}
				
                $this->Flash->success(__('Content updated successfully.'));
				return $this->redirect(['controller' => isset($this->request->params['section']) ? 
																$this->request->params['section'] : $this->request->params['controller'], 
										'action' => 'editedListings']);
            } else {
                $this->Flash->error(__('The row could not be save. Try again'));
            }
		} 
		
		// find the sub menu and sub sub menu of the selected content
		if($pcid != null) {
			$selectedPage = ($pcid == null || $pcid == $id) ? null : $this->PageContents->find('all', [
																			'conditions' => [
																				'PageContents.id' => $pcid
																			],
																			'contain' => [
																				'Menus.ParentMenus'
																			]
																		])->first();
																		
			if($selectedPage != null && $selectedPage->menu != null && $selectedPage->menu->has('parent_menu')) {				
				$parentMenu = $selectedPage->menu->parent_menu;
				
				// if($parentMenu->parent_menu_id != 0 && $parentMenu->parent_menu_id != $id) {
				if($parentMenu->parent_menu_id != 0) {
					$content_sub_menu_id = $parentMenu->id;	
					$content_sub_sub_menu_id = $selectedPage->menu_id;	
					$subMenus = $this->Menus->find('all')->where(['parent_menu_id'=>$parentMenu->id])->combine('id','name');
				}
				else {
					$content_sub_menu_id = $selectedPage->menu->id;	
					$subMenus = $this->Menus->find('all')->where(['parent_menu_id'=>$selectedPage->menu_id])->combine('id','name');
				}
			}
			else {
				$content_sub_menu_id = $pcid;
			}
		}
		
        $menu_id="";          
        $this->set(compact('pageTitle','parentMenus','content', 'images','menu_id','content_sub_menu_id','content_sub_sub_menu_id', 'subMenus'));
	}


	public function editMenu($id=null) {

		$menuitem=$this->Menus->find('All')->where(["slug"=>$this->slug])->first();
		if ($this->request->is(['post', 'put', 'patch'])) {
           
			$menuitem = $this->Menus->patchEntity($menuitem, $this->request->data);
            if ($this->Menus->save($menuitem)) {                        
                $this->Flash->success(__('Menu  item name change successfully.'));
            } else {
                $this->Flash->error(__('The row could not be edited. Try again'));
            }
        }           
        $this->set(compact('menuitem'));
	}

	// Enable featured
    public function enableListing($id = null) {
        if ($id) {
            $this->Contents->updateAll(['status' => 1], ['id' => $id]);
            $this->Flash->success(__('Content has been ENABLED successfully.'));
        }

        return $this->redirect($this->referer());
    }

    // Disable featured
    public function disableListing($id = null) {
        if ($id) {
            $this->Contents->updateAll(['status' => 99], ['id' => $id]);
            $this->Flash->success(__('Content has been DISABLED successfully.'));
        }

        return $this->redirect($this->referer());
    }

    // Remove content from the home
    public function removeFromHome($id = null) {
        if ($id) {
            $this->Contents->updateAll(['show_on_home' => 0], ['id' => $id]);
            $this->Flash->success(__('Content removed from the homepage.'));
        }

        return $this->redirect($this->referer());
    }

    // Show content on the home
    public function showOnHome($id = null) {
        if ($id) {
            $this->Contents->updateAll(['show_on_home' => 1], ['id' => $id]);
            $this->Flash->success(__('Content successfully show homepage.'));
        }

        return $this->redirect($this->referer());
    }

	public function pendingListings($id=null){
		$pageTitle = 'Pending Contents';
  
		// Retrieve the active menu from the slug
		$mc = $this->Menus->find('all')->where(['Menus.slug'=>$this->slug])->first();
        $listings = $this->PageContents->find('All')
										->contain([
											'Contents.ContentImages', 'Menus.ParentMenus'
										])
										->where([
											'Contents.status' => 0,
											'OR' => [
												['Menus.slug' => $this->slug],
												['ParentMenus.slug' => $this->slug],
												['ParentMenus.parent_menu_id'=>$mc->id]
											]
										])
										->order([
											'Menus.name' => 'ASC',
											'Contents.name' => 'ASC'
										]);
		
		$listings = $this->paginate($listings);

		$this->set(compact('pageTitle', 'listings'));
	}

	public function enableListings($id=null){
		$pageTitle = 'Pending Contents';
  
		// Retrieve the active menu from the slug
		$mc = $this->Menus->find('all')->where(['Menus.slug'=>$this->slug])->first();
		$listings = $this->PageContents->find('All')
										->contain([
											'Contents.ContentImages', 'Menus.ParentMenus'
										])
										->where([
											'Contents.status' => 1,
											'OR' => [
												['Menus.slug' => $this->slug],
												['ParentMenus.slug' => $this->slug],
												['ParentMenus.parent_menu_id'=>$mc->id]
											]
										])
										->order([
											'Menus.name' => 'ASC',
											'Contents.name' => 'ASC'
										]);
		
		$listings = $this->paginate($listings);
		$this->set(compact('pageTitle', 'listings'));
	}

	public function disableListings($id=null){
        $pageTitle = 'Disable Contents';
  
		// Retrieve the active menu from the slug
		$mc = $this->Menus->find('all')->where(['Menus.slug'=>$this->slug])->first();
		$listings = $this->PageContents->find('All')
										->contain([
											'Contents.ContentImages', 'Menus.ParentMenus'
										])
										->where([
											'Contents.status' => 99,
											'OR' => [
												['Menus.slug' => $this->slug],
												['ParentMenus.slug' => $this->slug],
												['ParentMenus.parent_menu_id'=>$mc->id]
											]
										])
										->order([
											'Menus.name' => 'ASC',
											'Contents.name' => 'ASC'
										]);
		
		$listings = $this->paginate($listings);
		$this->set(compact('pageTitle', 'listings'));
	}

	public function editedListings($id=null){
		$pageTitle = 'Edited Contents';
  
		// Retrieve the active menu from the slug
		$mc = $this->Menus->find('all')->where(['Menus.slug'=>$this->slug])->first();
		$listings = $this->PageContents->find('All')
										->contain([
											'Contents.ContentImages', 'Menus.ParentMenus'
										])
										->where([
											'Contents.status' => 2,
											'OR' => [
												['Menus.slug' => $this->slug],
												['ParentMenus.slug' => $this->slug],
												['ParentMenus.parent_menu_id'=>$mc->id]
											]
										])
										->order([
											'Menus.name' => 'ASC',
											'Contents.name' => 'ASC'
										]);
		
		$listings = $this->paginate($listings);
		$this->set(compact('pageTitle', 'listings'));
	}
	
	public function allListings($id=null){
        $pageTitle = 'All Contents';
  
		// Retrieve the active menu from the slug
		$mc = $this->Menus->find('all')->where(['Menus.slug'=>$this->slug])->first();
		$listings = $this->PageContents->find('All')
										->contain([
											'Contents.ContentImages', 'Menus.ParentMenus'
										])
										->where([
											'OR' => [
												['Menus.slug' => $this->slug],
												['ParentMenus.slug' => $this->slug],
												['ParentMenus.parent_menu_id'=>$mc->id]
											]
										])
										->order([
											'Menus.name' => 'ASC',
											'Contents.name' => 'ASC'
										]);
		
		$listings = $this->paginate($listings);
		$this->set(compact('pageTitle', 'listings'));
	}	

    public function removeImage($id = null) {
		$this->autoRender = false;
        $this->viewBuilder()->layout(false);

        $this->log('Ajax request received for Image removal', 'debug');
        $imageModel = TableRegistry::get('ContentImages');
        $imageItem = $imageModel->get($id);
        $this->log('image id to remove: ' . $imageItem->image_path, 'debug');
        $status = "Fail";

        if ($imageModel->delete($imageItem)) {
            $this->response->statusCode(200);
            $status = "Success";
        } else {
            $this->response->statusCode(500);
        }

        echo json_encode(array($status));
    }
}