<?php

namespace App\Controller;

use App\Controller\AppController;
use cake\ORM\TableRegistry;
use Cake\Utility\Inflector;
use Cake\I18n\Time;
use Cake\Event\Event;
use Cake\Core\Configure;

/**
 * Items Controller
 *
 * @property \App\Model\Table\ItemsTable $Items and AutoSparePartsTable $AutoSpareParts
 */
class MenusController extends AppController {

    public function initialize() {
        parent::initialize();
        $this->loadModel('Menus');
         $this->paginate = [
            'limit' => 50
        ];
    }

    public function beforeRender(Event $event)
    {
        parent::beforeRender($event);

    }
   
    public function isAuthorized($user) {

        return true;
    }

    /**
     *
     * @return void
     */
    public function index($action=null) {
      if (isset($this->request->query['search'])) {

            $listings = $this->Menus->searchMenus(1,$this->request->query['search']);
            $pageTitle = "All Listings";
        } else {
            $listings = $this->Menus->getAllMenus();
        }

        $pageTitle =" Sub Menus";
        $listings = $this->paginate($listings);
        $this->set(compact('pageTitle', 'listings'));
        $this->render('menu-listings');
     }

    public function menus() {
      
        if (isset($this->request->query['search'])) {

            $listings = $this->Menus->searchMenus(1,$this->request->query['search']);
            $pageTitle = "All Listings";
        } else {
            $listings = $this->Menus->getAllMenus();
        }

        $pageTitle =" Menus";
        $listings = $this->paginate($listings);
        $this->set(compact('pageTitle', 'listings'));
        $this->render('Menu-listings');
    }


 public function subMenus($section=null,$id) {
        if (isset($this->request->query['search'])) {

            $listings = $this->Menus->searchSubMenus($section,$this->request->query['search']);
            $pageTitle = "All Listings";
        } else {
        $listings = $this->Menus->find('all')->where(['parent_menu_id'=>$id]);
        }
 

        $pageTitle =  "Sub Menu";
        $listings = $this->paginate($listings);
         $actiontitle='SubMenu';
        $this->set(compact('pageTitle', 'listings','Menu','actiontitle'));
         $this->render('sub-menu-listings');
    }

     public function subSubMenus($section = null, $id = null) {
       
       if (isset($this->request->query['search'])) {

            $listings = $this->Menus->find('all')->where(['name like %'=>$this->request->query['search'],'parent_menu_id'=>$id]);
            $pageTitle = "All Listings";
        } else {
            $listings = $this->Menus->findSubSubMenus($id);
        }
        $pageTitle = " Sub Sub Menu";
        $actiontitle='SubSubMenu';
        $listings = $this->paginate($listings);
        $this->set(compact('pageTitle', 'listings','menu','actiontitle'));
         $this->render('sub-sub-menu-listings');
    }

     public  function addMenu($type = null){
     
       
        $menu = $this->Menus->newEntity();
        $parentData = [];
        if ($this->request->is('post')) {
            
             $this->request->data['slug'] = Inflector::slug($this->request->data['name']);       

            $menu = $this->Menus->patchEntity($menu, $this->request->data);
            if(empty($this->Menus->getMenuFromName($this->request->data['name']))){
            if ($this->Menus->save($menu)) {

                return $this->redirect(['action' => 'menu']);
            } else {
                $this->Flash->error(__('The Menu could not be saved. Please, try again.'));
            }
          }else{
            $this->Flash->error(__('The Menu name is already used.'));
          }
        }
    
        $pageSubTitle=' Menu';
         $pageTitle =  "Menu";
        $this->set(compact('Menu', 'pageSubTitle','pageTitle'));
     
}


     public  function editMenu($pid =null, $id=null){
     
       
        $menu = $this->Menus->get($id);
        $parentData = [];

        if ($this->request->is(['post', 'patch', 'put'])) {
         
          
            $this->request->data['slug'] = Inflector::slug($this->request->data['name']);    
 
            $menu = $this->Menus->patchEntity($menu, $this->request->data);

           if(empty($this->Menus->getMenuFromName($this->request->data['name']))){
            if ($this->Menus->save($Menu)) {

                return $this->redirect(['action' => 'Menu']);
            } else {
                $this->Flash->error(__('The Menu could not be updated. Please, try again.'));
            }
            }else{
            $this->Flash->error(__('The Menu name is already used.'));
          }
        }

       

        $pageSubTitle=' Menu';
         $pageTitle =  "Menu";
         $action='Menu';
        $this->set(compact('menu', 'pageTitle', 'pageSubTitle','pageTitle'));
     
}

 public  function addSubMenu($section = null, $id = null){
	 
        $menuDetails = [];
        $pageTitle = '';

        if (!empty($section)) {
            $menuDetails = $this->Menus->find('All')->where(['slug'=>$section])->first();
           
            $pageTitle = ucwords(str_replace('-', ' ', $menuDetails->name));
        }

        $menu = $this->Menus->newEntity();
        $parentData = [];
        if ($this->request->is('post')) {
         
        
         $count = $this->Menus->find('All')->where(['slug'=>$section,'parent_menu_id'=>$id])->count();
         $ps=($count>=1)?'-'.$count:'';
         $this->request->data['slug'] = Inflector::slug(strtolower($this->request->data['name'])).$ps;    
             $menu = $this->Menus->patchEntity($menu, $this->request->data);
        
        
             // Check if there is an image and then update the image path
            if(isset($this->request->data['image_path'])){
              $fileOK = $this->uploadFiles(Configure::read('IMAGE_PREPATH'), $this->request->data['image_path']);
    
              if(array_key_exists('urls', $fileOK)) {
             $menu->image_path = substr($fileOK['file_path'][0], Configure::read('IMAGE_PRELENGTH'), strlen($fileOK['file_path'][0]));
                 }
            }
            
            if ($this->Menus->save($menu)) {

                return $this->redirect(['controller'=>$section,'action' => 'subMenus',$id]);
            } else {
                $this->Flash->error(__('The Menu could not be saved. Please, try again.'));
            }
        }

        $pmid=$id;
        $pageSubTitle='Sub Menu';
         $actiontitle='SubMenu';
        $this->set(compact('menu', 'actiontitle', 'pmid', 'pageTitle', 'pageSubTitle'));
     
}

public  function editSubMenu($section = null, $id = null){
  

        $menuDetails = [];
        $pageTitle = '';

        $menu = $this->Menus->get($id);
     
        if ($this->request->is(['post', 'patch', 'put'])) {

               
           $sectionDetails = $this->Menus->find('All')->where(['slug'=>$section])->first();

            $menu = $this->Menus->patchEntity($menu, $this->request->data);
             // Check if there is an image and then update the image path
             if(isset($this->request->data['image_path'])){
                $fileOK = $this->uploadFiles(Configure::read('IMAGE_PREPATH'), $this->request->data['image_path']);
                
                if(array_key_exists('urls', $fileOK)) {
                    $menu->image_path = substr($fileOK['file_path'][0], Configure::read('IMAGE_PRELENGTH'), strlen($fileOK['file_path'][0]));
                }
            }


            if ($this->Menus->save($menu)) {

                 return $this->redirect(['controller'=>$section,'action' => 'subMenus',$sectionDetails->id]);
            } else {
                $this->Flash->error(__('The Menu could not be saved. Please, try again.'));
            }
        }

        
       
        $pageSubTitle='Sub Menu';
         $actiontitle='SubMenu';
        $this->set(compact( 'menu', 'actiontitle', 'pageTitle', 'pageSubTitle'));
     
}

public  function addSubSubMenu($section = null, $id = null){
         $parentMenus = $this->Menus->find('all')->where(['parent_menu_id'=>$id])->combine('id','name');
      
        $menu = $this->Menus->newEntity();
        $parentData = [];
        if ($this->request->is('post')) {
           $count = $this->Menus->find('All')->where(['slug'=>$section,'parent_menu_id'=>$id])->count();
         $ps=($count>=1)?'-'.$count:'';
         $this->request->data['slug'] = Inflector::slug(strtolower($this->request->data['name'])).$ps;       
            $menu = $this->Menus->patchEntity($menu, $this->request->data);

 
       
            if ($this->Menus->save($menu)) {

                return $this->redirect(['controller'=>$section,'action' => 'subSubMenus',$id]);
            } else {
                $this->Flash->error(__('The sub sub Menu could not be saved. Please, try again.'));
            }
        }

       
    
     
        $pageSubTitle='Sub Sub Menu';
         $actiontitle='SubSubMenu';
        $this->set(compact('parentMenus', 'menu', 'actiontitle', 'pageTitle', 'pageSubTitle'));
     
}


public  function editSubSubMenu($section = null, $id = null){
        $menuDetails = [];
        $pageTitle = '';

        $pmid = $this->Menus->find('All')->where(['slug'=>$section])->first()->id;
          $parentMenus = $this->Menus->find('all')->where(['parent_menu_id'=>$pmid])->combine('id','name');
        $menu = $this->Menus->get($id);
     
        if ($this->request->is(['post', 'patch', 'put'])) {

               
           $sectionDetails = $this->Menus->find('All')->where(['slug'=>$section])->first();

            $menu = $this->Menus->patchEntity($menu, $this->request->data);

            if ($this->Menus->save($menu)) {

                 return $this->redirect(['controller'=>$section,'action' => 'subSubMenus',$sectionDetails->id]);
            } else {
                $this->Flash->error(__('The Menu could not be saved. Please, try again.'));
            }
        }

        
       
        $pageSubTitle='Sub Sub Menu';
         $actiontitle='SubSubMenu';
        $this->set(compact('parentMenus', 'menu', 'actiontitle', 'pageTitle', 'pageSubTitle'));
     
}




 public function updateSubMenu($id = null)
    {
        $this->autoRender = false;

        $subMenu = $this->Menus->updateSubMenu($id);
     
        $this->response->statusCode(200);
        echo json_encode(array($subMenu));
        $this->log(json_encode(array($subMenu)), 'debug');
    } 

   // enable featured
    public function enableMenu($section=null,$id = null) {
        if ($id) {
            $this->Menus->updateAll(['status' => 1], ['id' => $id]);
            $this->Flash->success(__('Menu has been ENABLED successfully.'));
        }

        return $this->redirect($this->referer());
    }

    // disable featured
    public function disableMenu($section=null,$id = null) {
        if ($id) {
            $this->Menus->updateAll(['status' => 99], ['id' => $id]);
            $this->Flash->success(__('Menu has been DISABLED successfully.'));
        }

        return $this->redirect($this->referer());
    }

    // Remove menu from the home page
    public function removeMenuFromHome($id = null) {
        if ($id) {
            $this->Menus->updateAll(['show_on_home' => 0], ['id' => $id]);
            $this->Flash->success(__('Menu has been removed from the homepage.'));
        }

        return $this->redirect($this->referer());
    }

    // Show menu on the home page
    public function showMenuOnHome($id = null) {
        if ($id) {
            $this->Menus->updateAll(['show_on_home' => 1], ['id' => $id]);
            $this->Flash->success(__('Menu successfully showing on homepage.'));
        }

        return $this->redirect($this->referer());
    }
}
