<?php
namespace App\Controller;

use App\Controller\AppController;
use cake\ORM\TableRegistry;
use Cake\I18n\Time;
use Cake\Event\Event;
use Cake\Core\Configure;

/**
 * Items Controller
 *
 * @property \App\Model\Table\ItemsTable $Items and AutoSparePartsTable $AutoSpareParts
 */
class ProductsController extends AppController {
    protected $slug="products";

    public function initialize() {
        parent::initialize();        
        $this->paginate = [
            'limit' => 50
        ];

    }


    public function beforeRender(Event $event) {
        parent::beforeRender($event);
    }

    public function isAuthorized($user) {
        $action = $this->request->params['action'];

        return true;
    }

    /**
     * Index method
     *
     * @return void
     */


    public function index() {
        $pageTitle = 'All Products';

        $listings = $this->PageProducts->find('All')->contain(['Products.ProductImages','Menus'])->where(['Menus.slug'=>$this->slug]);
        $listings = $this->paginate($listings);
        $this->set(compact('pageTitle', 'listings'));
    }

    public function addContent($id=null) {
        //dd($this->request->data());
        $images=[];
        $tagId="";
        $categories=$this->ProductCategories->find("All")->combine('id','name');
        $product = $this->Products->newEntity();        
        
        if ($this->request->is(['post'])) {                   
            $product = $this->Products->patchEntity($product, $this->request->data);

            if ($this->Products->save($product)) {

                $pageproduct = $this->PageProducts->newEntity(); 
                $this->request->data["menu_id"]=$id;
                //$this->request->data['publish_date'] = Time::parseDateTime($this->request->data['publish_date']);
                $this->request->data["product_id"]=$product->id;
                $pc=$this->PageProducts->find('All')->where(["menu_id"=> $this->request->data["menu_id"],"product_id"=>$this->request->data["product_id"]]);
                if(empty($pc->toArray())){
                $pageproduct = $this->PageProducts->patchEntity($pageproduct, $this->request->data);
                    $this->PageProducts->save($pageproduct);

                }

                $images = [];
                for($i = 1; $i < 6; $i++) {
                $image_field = 'image' . $i;

                if(isset($this->request->data[$image_field])){
                        $imageinfo = $this->request->data[$image_field]['tmp_name'] != null ? getimagesize($this->request->data[$image_field]['tmp_name']) : 'temp';
                        $fileOK = $this->uploadFiles(Configure::read('IMAGE_PREPATH'), $this->request->data[$image_field]);

                        if(array_key_exists('urls', $fileOK)) {  							
                            $image = $this->ProductImages->newEntity([
                                'image_path' => substr($fileOK['file_path'][0], Configure::read('IMAGE_PRELENGTH'), strlen($fileOK['file_path'][0])),
                                'product_id' => $product->id
                            ]);
                            $image = $this->ProductImages->patchEntity($image, $this->request->data);
                            array_push($images, $image);
                        }
                    }
                }

                if(sizeof($images > 0)) {
                    $this->ProductImages->saveMany($images);
                }
                
                $this->Flash->success(__('Product added successfully.'));
                return $this->redirect(['action' => 'pendingContents']);
            } else {
                $this->Flash->error(__('The row could not be save. Try again'));
            }
        } 
        $menu_id=$id;      
        $this->set(compact('product','images','menu_id','categories'));

    }

    public function editContent($id=null,$pid=null) {
      //  dd($this->request->data());
        $images=[];
        $tagId="";
        $images = $this->ProductImages->find("All")->where(["product_id"=>$pid]); 
        $categories=$this->ProductCategories->find("All")->combine('id','name');
        $product = $this->Products->get($pid);        

        if ($this->request->is(['post', 'put', 'patch'])) {
            $this->request->data['status'] = 2; 
            $this->request->data["product_id"] = $product->id;
            $product = $this->Products->patchEntity($product, $this->request->data);
            
            if ($this->Products->save($product)) {
                $images = [];
                for($i = 1; $i < 6; $i++) {
                $image_field = 'image' . $i;

                if(isset($this->request->data[$image_field])){
                        $imageinfo = $this->request->data[$image_field]['tmp_name'] != null ? getimagesize($this->request->data[$image_field]['tmp_name']) : 'temp';
                        $fileOK = $this->uploadFiles(Configure::read('IMAGE_PREPATH'), $this->request->data[$image_field]);

                        if(array_key_exists('urls', $fileOK)) {  							
                            $image = $this->ProductImages->newEntity([
                                'image_path' => substr($fileOK['file_path'][0], Configure::read('IMAGE_PRELENGTH'), strlen($fileOK['file_path'][0])),
                                'product_id' => $product->id
                            ]);
                            $image = $this->ProductImages->patchEntity($image, $this->request->data);
                            array_push($images, $image);
                        }
                    }
                }

                if(sizeof($images > 0)) {
                    $this->ProductImages->saveMany($images);
                }

                $this->Flash->success(__('Product added successfully.'));
                return $this->redirect(['action' => 'editedContents']);
            } else {
                $this->Flash->error(__('The row could not be save. Try again'));
            }
        }
        
        $menu_id=$id;
        $this->set(compact('product','images','menu_id','categories'));
    }


public function editMenu($id=null) {

    $menuitem=$this->Menus->find('All')->where(["slug"=>$this->slug])->first();

    
        if ($this->request->is(['post', 'put', 'patch'])) {
        
            $menuitem = $this->Menus->patchEntity($menuitem, $this->request->data);
            
            if ($this->Menus->save($menuitem)) {

                        
                $this->Flash->success(__('Menu  item name change successfully.'));
            } else {
                $this->Flash->error(__('The row could not be edited. Try again'));
            }
        }           
        $this->set(compact('menuitem'));



}

// enable featured
    public function enableContent($id = null) {
        if ($id) {
            $this->Products->updateAll(['status' => 1], ['id' => $id]);
            $this->Flash->success(__('Category has been ENABLED successfully.'));
        }

        return $this->redirect($this->referer());
    }

    // disable featured
    public function disableContent($id = null) {
        if ($id) {
            $this->Products->updateAll(['status' => 99], ['id' => $id]);
            $this->Flash->success(__('Category has been DISABLED successfully.'));
        }

        return $this->redirect($this->referer());
    }
public function pendingContents($id=null){
        $pageTitle = 'Pending Contents';

        $listings = $this->PageProducts->find('All')->contain(['Products.ProductImages','Menus'])->where(['Menus.slug'=>$this->slug,'Products.status'=>0]);
        $listings = $this->paginate($listings);

        $this->set(compact('pageTitle', 'listings'));
}


public function enableContents($id=null){
        $pageTitle = 'Enable Contents';

        $listings = $this->PageProducts->find('All')->contain(['Products.ProductImages','Menus'])->where(['Menus.slug'=>$this->slug,'Products.status'=>1]);
        $listings = $this->paginate($listings);
    
        $this->set(compact('pageTitle', 'listings'));
}
public function disableContents($id=null){
        $pageTitle = 'Disable Contents';

        $listings = $this->PageProducts->find('All')->contain(['Products.ProductImages','Menus'])->where(['Menus.slug'=>$this->slug,'Products.status'=>99]);
        $listings = $this->paginate($listings);
    
        $this->set(compact('pageTitle', 'listings'));
}

public function editedContents($id=null){
        $pageTitle = 'Edited Contents';

        $listings = $this->PageProducts->find('All')->contain(['Products.ProductImages','Menus'])->where(['Menus.slug'=>$this->slug,'Products.status'=>2]);
        $listings = $this->paginate($listings);
    
        $this->set(compact('pageTitle', 'listings'));
}

public function featuredContents($id=null){
        $pageTitle = 'featured Products';

        $listings = $this->PageProducts->find('All')->contain(['Products.ProductImages','Menus'])->where(['Menus.slug'=>$this->slug,'Products.featured'=>1]);
        $listings = $this->paginate($listings);
    
        $this->set(compact('pageTitle', 'listings'));
}
public function allContents($id=null){
        $pageTitle = 'All Contents';

        $listings = $this->PageProducts->find('All')->contain(['Products.ProductImages','Menus'])->where(['Menus.slug'=>$this->slug]);
        $listings = $this->paginate($listings);
    
        $this->set(compact('pageTitle', 'listings'));
}

public function uploadFiles($folder, $file, $itemId = null) {
        // setup dir names absolute and relative
        $folder_url = WWW_ROOT.$folder;
        $rel_url = $folder;
        
        // create the folder if it does not exist
        if(!is_dir($folder_url)) {
            mkdir($folder_url);
        }
            
        // if itemId is set create an item folder
        if($itemId) {
            // set new absolute folder
            $folder_url = WWW_ROOT.$folder.'/'.$itemId; 
            // set new relative folder
            $rel_url = $folder.'/'.$itemId;
            // create directory
            if(!is_dir($folder_url)) {
                mkdir($folder_url);
            }
        }
        

        
        // list of permitted file types : pictures and vidoes
        $permitted = array('image/jpeg','image/pjpeg','image/png');
        $result='';
        
        // replace spaces with underscores
        $filename = str_replace(' ', '_', $file['name']);
        // assume filetype is false
        $typeOK = false;
        // check filetype is ok
        foreach($permitted as $type) {
            if($type == $file['type']) {
                $typeOK = true;
                break;
            }
        }
        
        // if file type ok upload the file
        if($typeOK) {
            // switch based on error code
            switch($file['error']) {
                case 0:
                    // create unique filename and upload file
                    ini_set('date.timezone', 'Europe/London');
                    $now = date('Y-m-d-His');
                    $full_url = $folder_url.'/'.$now.$filename;
                    $url = $rel_url.'/'.$now.$filename;
                
                    $success = move_uploaded_file($file['tmp_name'], $url);
                                        // if upload was successful
                    if($success) {
                        // save the url of the file
                        $result['urls'][] = $url;
                        $result['file_type'][] = $file['type'];
                        $result['name'][] = $file['name'];
                        $result['size'][] = $file['size'];
                        $result['file_path'][] = $url;
                    } else {
                        $result['errors'][] = "Error uploaded $filename. Please try again.";
                    }
                    break;
                case 3:
                    // an error occured
                    $result['errors'][] = "Error uploading $filename. Please try again.";
                    break;
                default:
                    // an error occured
                    $result['errors'][] = "System error uploading $filename. Contact webmaster.";
                    break;
            }
        } elseif($file['error'] == 4) {
            // no file was selected for upload
            $result['nofiles'][] = "No file Selected";
        } else {
            // unacceptable file type
            $result['errors'][] = "$filename cannot be uploaded. Acceptable file types: gif, jpg, png.";
        }
        
        return $result;
    } 

    public function removeImage($id = null) {
        $this->autoRender = false;
        $this->viewBuilder()->layout(false);

        $this->log('Ajax request received for Image removal', 'debug');
        $imageModel = TableRegistry::get('ProductImages');
        $imageItem = $imageModel->get($id);
        $this->log('image id to remove: ' . $imageItem->image_path, 'debug');
        $status = "Fail";

        if ($imageModel->delete($imageItem)) {
            $this->response->statusCode(200);
            $status = "Success";
        } else {
            $this->response->statusCode(500);
        }

        echo json_encode(array($status));
    }

}