<?php
namespace App\Model\Entity;

use Cake\ORM\Entity;

/**
 * Product Entity
 *
 * @property int $id
 * @property string $product_line_id
 * @property string $name
 * @property string $bar_code
 * @property float $price
 * @property int $product_color_id
 * @property int $product_make_id
 * @property int $product_model_id
 * @property int $product_volume_id
 * @property int $product_size_id
 * @property int $product_age_id
 * @property string $description
 * @property int $featured
 * @property \Cake\I18n\FrozenTime $featured_start_date
 * @property \Cake\I18n\FrozenTime $featured_end_date
 * @property int $viewed
 * @property \Cake\I18n\FrozenTime $date_created
 * @property int $status
 *
 * @property \App\Model\Entity\ProductLine $product_line
 * @property \App\Model\Entity\ProductColor $product_color
 * @property \App\Model\Entity\ProductMake $product_make
 * @property \App\Model\Entity\ProductModel $product_model
 * @property \App\Model\Entity\ProductVolume $product_volume
 * @property \App\Model\Entity\ProductSize $product_size
 * @property \App\Model\Entity\ProductAge $product_age
 * @property \App\Model\Entity\OrderLine[] $order_lines
 * @property \App\Model\Entity\PageProduct[] $page_products
 * @property \App\Model\Entity\ProductImage[] $product_images
 * @property \App\Model\Entity\ProductSetting[] $product_settings
 * @property \App\Model\Entity\SalesOrderLine[] $sales_order_lines
 */
class Product extends Entity
{

    /**
     * Fields that can be mass assigned using newEntity() or patchEntity().
     *
     * Note that when '*' is set to true, this allows all unspecified fields to
     * be mass assigned. For security purposes, it is advised to set '*' to false
     * (or remove it), and explicitly make individual fields accessible as needed.
     *
     * @var array
     */
    protected $_accessible = [
        'product_line_id' => true,
        'name' => true,
        'description'=> true,
        'quantity'=> true,
        'category_id'=> true,
        'product_code' => true,
        'price' => true,
        // 'product_color_id' => true,
        // 'product_make_id' => true,
        // 'product_model_id' => true,
        // 'product_volume_id' => true,
        // 'product_size_id' => true,
        // 'product_age_id' => true,
        'description' => true,
        'featured' => true,
        'featured_start_date' => true,
        'featured_end_date' => true,
        'viewed' => true,
        'date_created' => true,
        'manufacturer'=> true,
        'order_value'=> true,
        'status' => true,
        // 'product_line' => false,
        // 'product_color' => false,
        // 'product_make' => true,
        // 'product_model' => true,
        // 'product_volume' => true,
        // 'product_size' => true,
        // 'product_age' => true,
        //'order_lines' => true,
        'page_products' => true,
        'product_images' => true
        // 'product_settings' => true,
        // 'sales_order_lines' => true
    ];
}
