<?php

namespace App\Controller;

use App\Controller\AppController;
use cake\ORM\TableRegistry;
use Cake\I18n\Time;
use Cake\Event\Event;

/**
 * Items Controller
 *
 * @property \App\Model\Table\ItemsTable $Items and AutoSparePartsTable $AutoSpareParts
 */
class EventsController extends AppController {

    public function initialize() {
        parent::initialize();        
         $this->loadModel('Events');
        $this->paginate = [
            'limit' => 50
        ];
    }


 public function beforeRender(Event $event) {
        parent::beforeRender($event);

    }

    public function isAuthorized($user) {
        $action = $this->request->params['action'];

        return true;
    }

    /**
     * Index method
     *
     * @return void
     */


    public function index() {
       $pageTitle = 'All Events';
         $llistings = $this->Events->find('all');
         $listings = $this->paginate($llistings);
         $this->set(compact('pageTitle', 'listings'));
    }

 public function add() {
        $cmsevent = $this->Events->newEntity();        
        $pageTitle = 'Add Event';
        if ($this->request->is(['post'])) {
             $image_field = 'image1';
             if(isset($this->request->data[$image_field])){
                $imageinfo = $this->request->data[$image_field]['tmp_name'] != null ? getimagesize($this->request->data[$image_field]['tmp_name']) : 'temp';
                $fileOK = $this->uploadFiles('../../webroot/img', $this->request->data[$image_field]);
                            if(array_key_exists('urls', $fileOK)) {                                             
                                $this->request->data['image_path'] = substr($fileOK['file_path'][0],18,strlen($fileOK['file_path'][0]));
            
                            } 
                        }

             $this->request->data['event_start_date'] = Time::parseDate($this->request->data['event_start_date']);
            $this->request->data['event_end_date'] = Time::parseDate($this->request->data['event_end_date']);

            $this->request->data['start_time'] = Time::parseTime($this->request->data['start_time']);
            $this->request->data['end_time'] = Time::parseTime($this->request->data['end_time']);

            $cmsevent = $this->Events->patchEntity($cmsevent, $this->request->data);
            if ($this->Events->save($cmsevent)) {
                $this->Flash->success(__('Event added successfully.'));
                return $this->redirect(['action' => 'pendingListings']);
            } else {
                $this->Flash->error(__('The row could not be save. Try again'));
            }
        }        
        $this->set(compact('pageTitle','cmsevent', 'cmscatlist','sectionlist'));

  }


  public function addImage() {
        $cmsevent = $this->EventImages->newEntity();        
        $pageTitle = 'Add Event Images';
        if ($this->request->is(['post'])) {
             $image_field = 'image1';
             if(isset($this->request->data[$image_field])){
                $imageinfo = $this->request->data[$image_field]['tmp_name'] != null ? getimagesize($this->request->data[$image_field]['tmp_name']) : 'temp';
                $fileOK = $this->uploadFiles('../../webroot/img', $this->request->data[$image_field]);
                            if(array_key_exists('urls', $fileOK)) {                                             
                                $this->request->data['image_path'] = substr($fileOK['file_path'][0],18,strlen($fileOK['file_path'][0]));
                                 $this->request->data['name'] =$fileOK['name'][0];
                                 $this->request->data['image_category_id'] =1;
            
                            } 
                        }


            $cmsevent = $this->EventImages->patchEntity($cmsevent, $this->request->data);
            if ($this->EventImages->save($cmsevent)) {
                $this->Flash->success(__('Event added successfully.'));
                return $this->redirect(['action' => 'imageList']);
            } else {
                $this->Flash->error(__('The row could not be save. Try again'));
            }
        }        
        $this->set(compact('pageTitle','cmsevent', 'cmscatlist','sectionlist'));

  }
  public function edit($id) {

        $cmsevent = $this->Events->get($id);        
        $pageTitle = 'Edit Event';
        if ($this->request->is(['post', 'put', 'patch'])) {
             $image_field = 'image1';
             if(isset($this->request->data[$image_field])){
                $imageinfo = $this->request->data[$image_field]['tmp_name'] != null ? getimagesize($this->request->data[$image_field]['tmp_name']) : 'temp';
                $fileOK = $this->uploadFiles('../../webroot/img', $this->request->data[$image_field]);
                            if(array_key_exists('urls', $fileOK)) {                                             
                                $this->request->data['image_path'] = substr($fileOK['file_path'][0],18,strlen($fileOK['file_path'][0]));
            
                            } 
                        }
             $this->request->data['status'] = 2;
              $this->request->data['event_start_date'] = Time::parseDate($this->request->data['event_start_date']);
            $this->request->data['event_end_date'] = Time::parseDate($this->request->data['event_end_date']);

            $this->request->data['start_time'] = Time::parseTime($this->request->data['start_time']);
            $this->request->data['end_time'] = Time::parseTime($this->request->data['end_time']);

            $cmsevent = $this->Events->patchEntity($cmsevent, $this->request->data);
            if ($this->Events->save($cmsevent)) {
                $this->Flash->success(__('Event edited successfully.'));
                return $this->redirect(['action' => 'pendingListings']);
            } else {
                $this->Flash->error(__('The row could not be save. Try again'));
            }
        }        
        $this->set(compact('pageTitle','cmsevent', 'cmscatlist','sectionlist'));   
  }


public function pendingListings(){
         $pageTitle = 'Pending Events';
         $llistings = $this->Events->find('all')->where(['status' =>0]);
         $listings = $this->paginate($llistings);
         $this->set(compact('pageTitle', 'listings'));
 }
 public function imageList(){
         $pageTitle = 'Event Images List';
         $llistings = $this->EventImages->find('all');
         $listings = $this->paginate($llistings);
         $this->set(compact('pageTitle', 'listings'));
 }

 public function enableListings(){
         $pageTitle = 'Enable Events';

         $llistings = $this->Events->find('all')->where(['status' =>1]);
         $listings = $this->paginate($llistings);
         $this->set(compact('pageTitle', 'listings'));
 }

public function enableImages(){
         $pageTitle = 'Enable Events';

         $llistings = $this->EventImages->find('all')->where(['status' =>1]);
         $listings = $this->paginate($llistings);
         $this->set(compact('pageTitle', 'listings'));
 }

 public function disableListings(){
         $pageTitle = 'Disable Events';
         $llistings = $this->Events->find('all')->where(['status' =>99]);
         $listings = $this->paginate($llistings);
         $this->set(compact('pageTitle', 'listings'));
 }

  public function disableImages(){
         $pageTitle = 'Disable Events';
         $llistings = $this->EventImages->find('all')->where(['status' =>99]);
         $listings = $this->paginate($llistings);
         $this->set(compact('pageTitle', 'listings'));
 }

public function editedListings(){
         $pageTitle = 'Edited Events';
         $llistings = $this->Events->find('all')->where(['status' =>2]);
         $listings = $this->paginate($llistings);
         $this->set(compact('pageTitle', 'listings'));
 }

 public function allListings($id=null){
        $pageTitle = 'All Events';
  
         $listings = $this->Events->find('all');
         $listings = $this->paginate($listings);
         $this->set(compact('pageTitle', 'listings'));
 }


public function enable($id=null)
  {
    $this->viewBuilder()->layout(false);
    $event = $this->Events->get($id);


    $this->request->data['status'] = 1;
    $event = $this->Events->patchEntity($event, $this->request->data);
    if ($this->Events->save($event)) {
      $this->Flash->success(__('event Enabled'));
    } else {
      $this->Flash->error(__('Error Occurred'));
    }
    
    return $this->redirect([ 'action' => 'pendingListings']);
  }

  public function enableImage($id=null)
  {
    $this->viewBuilder()->layout(false);
    $event = $this->EventImages->get($id);


    $this->request->data['status_id'] = 1;
    $event = $this->EventImages->patchEntity($event, $this->request->data);
    if ($this->EventImages->save($event)) {
      $this->Flash->success(__('event Image Enabled'));
    } else {
      $this->Flash->error(__('Error Occurred'));
    }
    
    return $this->redirect([ 'action' => 'imageList']);
  }
  
  

  public function disable($id=null)
  {
    $this->viewBuilder()->layout(false);
    $event = $this->Events->get($id);
    
    $this->request->data['status'] =99;
    $event = $this->Events->patchEntity($event, $this->request->data);
    if ($this->Events->save($event)) {
      $this->Flash->success(__('event Disabled'));
    } else {
      $this->Flash->error(__('Error Occurred'));
    }
    
    return $this->redirect(['action' => 'pendingListings']);
  } 

  public function disableImage($id=null)
  {
    $this->viewBuilder()->layout(false);
    $event = $this->EventImages->get($id);
    
    $this->request->data['status_id'] =99;
    $event = $this->EventImages->patchEntity($event, $this->request->data);
    if ($this->EventImages->save($event)) {
      $this->Flash->success(__('event Image  Disabled'));
    } else {
      $this->Flash->error(__('Error Occurred'));
    }
    
    return $this->redirect(['action' => 'imageList']);
  }

 public function editMenu($id=null) {

      $menuitem=$this->Menus->find('All')->where(["slug"=>$this->slug])->first();
 
     
           if ($this->request->is(['post', 'put', 'patch'])) {
           
              $menuitem = $this->Menus->patchEntity($menuitem, $this->request->data);
            
            if ($this->Menus->save($menuitem)) {

                        
                $this->Flash->success(__('Menu  item name change successfully.'));
            } else {
                $this->Flash->error(__('The row could not be edited. Try again'));
            }
        }           
        $this->set(compact('menuitem'));



  }

  public function uploadFiles($folder, $file, $itemId = null) {
        // setup dir names absolute and relative
        $folder_url = WWW_ROOT.$folder;
        $rel_url = $folder;
        
        // create the folder if it does not exist
        if(!is_dir($folder_url)) {
            mkdir($folder_url);
        }
            
        // if itemId is set create an item folder
        if($itemId) {
            // set new absolute folder
            $folder_url = WWW_ROOT.$folder.'/'.$itemId; 
            // set new relative folder
            $rel_url = $folder.'/'.$itemId;
            // create directory
            if(!is_dir($folder_url)) {
                mkdir($folder_url);
            }
        }
        

        
        // list of permitted file types : pictures and vidoes
        $permitted = array('image/jpeg','image/pjpeg','image/png');
        $result='';
        
        // replace spaces with underscores
        $filename = str_replace(' ', '_', $file['name']);
        // assume filetype is false
        $typeOK = false;
        // check filetype is ok
        foreach($permitted as $type) {
            if($type == $file['type']) {
                $typeOK = true;
                break;
            }
        }
        
        // if file type ok upload the file
        if($typeOK) {
            // switch based on error code
            switch($file['error']) {
                case 0:
                    // create unique filename and upload file
                    ini_set('date.timezone', 'Europe/London');
                    $now = date('Y-m-d-His');
                    $full_url = $folder_url.'/'.$now.$filename;
                    $url = $rel_url.'/'.$now.$filename;
                
                    $success = move_uploaded_file($file['tmp_name'], $url);
                                        // if upload was successful
                    if($success) {
                        // save the url of the file
                        $result['urls'][] = $url;
                        $result['file_type'][] = $file['type'];
                        $result['name'][] = $file['name'];
                        $result['size'][] = $file['size'];
                        $result['file_path'][] = $url;
                    } else {
                        $result['errors'][] = "Error uploaded $filename. Please try again.";
                    }
                    break;
                case 3:
                    // an error occured
                    $result['errors'][] = "Error uploading $filename. Please try again.";
                    break;
                default:
                    // an error occured
                    $result['errors'][] = "System error uploading $filename. Contact webmaster.";
                    break;
            }
        } elseif($file['error'] == 4) {
            // no file was selected for upload
            $result['nofiles'][] = "No file Selected";
        } else {
            // unacceptable file type
            $result['errors'][] = "$filename cannot be uploaded. Acceptable file types: gif, jpg, png.";
        }
        
        return $result;
    } 
 

}