<?php

namespace App\Controller;

use App\Controller\AppController;
use cake\ORM\TableRegistry;
use Cake\I18n\Time;
use Cake\Event\Event;

/**
 * Items Controller
 *
 * @property \App\Model\Table\ItemsTable $Items and AutoSparePartsTable $AutoSpareParts
 */
class TrainingController extends AppController {

    public function initialize() {
        parent::initialize();        
         $this->loadModel('Training');
        $this->paginate = [
            'limit' => 50
        ];
    }


 public function beforeRender(Event $event) {
        parent::beforeRender($event);

    }

    public function isAuthorized($user) {
        $action = $this->request->params['action'];

        return true;
    }

    /**
     * Index method
     *
     * @return void
     */


    public function index() {
         $llistings = $this->Training->find('all')->where(['status' =>0]);
         $listings = $this->paginate($llistings);
         $this->set(compact('pageTitle', 'listings'));
    }

 public function add() {
        $cmstraining = $this->Training->newEntity();        
        $pageTitle = 'Add Training';
        if ($this->request->is(['post'])) {
             $image_field = 'image1';
             if(isset($this->request->data[$image_field])){
                $imageinfo = $this->request->data[$image_field]['tmp_name'] != null ? getimagesize($this->request->data[$image_field]['tmp_name']) : 'temp';
                $fileOK = $this->uploadFiles('img/uploads', $this->request->data[$image_field]);
                            if(array_key_exists('urls', $fileOK)) {                                             
                                $this->request->data['image_path'] = substr($fileOK['file_path'][0],4,strlen($fileOK['file_path'][0]));
            
                            } 
                        }
             $this->request->data['start_date'] = Time::parseDate($this->request->data['start_date']);
             $this->request->data['end_date'] = Time::parseDate($this->request->data['end_date']);
             $this->request->data['application_start_date'] = Time::parseDate($this->request->data['application_start_date']);
            $this->request->data['application_end_date'] = Time::parseDate($this->request->data['application_end_date']);

            $this->request->data['start_time'] = Time::parseTime($this->request->data['start_time']);
            $this->request->data['end_time'] = Time::parseTime($this->request->data['end_time']);

            $cmstraining = $this->Training->patchEntity($cmstraining, $this->request->data);
            if ($this->Training->save($cmstraining)) {
                $this->Flash->success(__('Training added successfully.'));
                return $this->redirect(['action' => 'pendingListings']);
            } else {
                $this->Flash->error(__('The row could not be save. Try again'));
            }
        }        
        $this->set(compact('pageTitle','cmstraining', 'cmscatlist','sectionlist'));

  }
  public function edit($id) {

        $cmstraining = $this->Training->get($id);        
        $pageTitle = 'Edit Training';
        if ($this->request->is(['post', 'put', 'patch'])) {
             $image_field = 'image1';
             if(isset($this->request->data[$image_field])){
                $imageinfo = $this->request->data[$image_field]['tmp_name'] != null ? getimagesize($this->request->data[$image_field]['tmp_name']) : 'temp';
                $fileOK = $this->uploadFiles('img/uploads', $this->request->data[$image_field]);
                            if(array_key_exists('urls', $fileOK)) {                                             
                                $this->request->data['image_path'] = substr($fileOK['file_path'][0],4,strlen($fileOK['file_path'][0]));
            
                            } 
                        }
             $this->request->data['status'] = 2;
              $this->request->data['start_date'] = Time::parseDate($this->request->data['start_date']);
             $this->request->data['end_date'] = Time::parseDate($this->request->data['end_date']);
             $this->request->data['application_start_date'] = Time::parseDate($this->request->data['application_start_date']);
            $this->request->data['application_end_date'] = Time::parseDate($this->request->data['application_end_date']);

            $this->request->data['start_time'] = Time::parseTime($this->request->data['start_time']);
            $this->request->data['end_time'] = Time::parseTime($this->request->data['end_time']);
            $cmstraining = $this->Training->patchEntity($cmstraining, $this->request->data);
            if ($this->CmsTraining->save($cmstraining)) {
                $this->Flash->success(__('Training added successfully.'));
                return $this->redirect(['action' => 'pendingListings']);
            } else {
                $this->Flash->error(__('The row could not be save. Try again'));
            }
        }        
        $this->set(compact('pageTitle','cmstraining', 'cmscatlist','sectionlist'));   
  }


public function pendingListings(){
         $pageTitle = 'Pending Training';
         $llistings = $this->Training->find('all')->where(['status' =>0]);
         $listings = $this->paginate($llistings);
         $this->set(compact('pageTitle', 'listings'));
 }

 public function enableListings(){
         $pageTitle = 'Enable Training';

         $llistings = $this->Training->find('all')->where(['status' =>1]);
         $listings = $this->paginate($llistings);
         $this->set(compact('pageTitle', 'listings'));
 }
 public function disableListings(){
         $pageTitle = 'Disable Training';
         $llistings = $this->Training->find('all')->where(['status' =>99]);
         $listings = $this->paginate($llistings);
         $this->set(compact('pageTitle', 'listings'));
 }

public function editedListings(){
         $pageTitle = 'Edited Training';
         $llistings = $this->Training->find('all')->where(['status' =>2]);
         $listings = $this->paginate($llistings);
         $this->set(compact('pageTitle', 'listings'));
 }

public function enable($id=null)
  {
    $this->viewBuilder()->layout(false);
    $training = $this->Training->get($id);


    $this->request->data['status'] = 1;
    $training = $this->Training->patchEntity($training, $this->request->data);
    if ($this->Training->save($training)) {
      $this->Flash->success(__('Training Enabled'));
    } else {
      $this->Flash->error(__('Error Occurred'));
    }
    
    return $this->redirect([ 'action' => 'pendingListings']);
  }
  

  public function disable($id=null)
  {
    $this->viewBuilder()->layout(false);
    $training = $this->Training->get($id);
    
    $this->request->data['status'] =99;
    $training = $this->Training->patchEntity($training, $this->request->data);
    if ($this->Training->save($training)) {
      $this->Flash->success(__('Training Disabled'));
    } else {
      $this->Flash->error(__('Error Occurred'));
    }
    
    return $this->redirect(['action' => 'pendingListings']);
  } 


  public function uploadFiles($folder, $file, $itemId = null) {
        // setup dir names absolute and relative
        $folder_url = WWW_ROOT.$folder;
        $rel_url = $folder;
        
        // create the folder if it does not exist
        if(!is_dir($folder_url)) {
            mkdir($folder_url);
        }
            
        // if itemId is set create an item folder
        if($itemId) {
            // set new absolute folder
            $folder_url = WWW_ROOT.$folder.'/'.$itemId; 
            // set new relative folder
            $rel_url = $folder.'/'.$itemId;
            // create directory
            if(!is_dir($folder_url)) {
                mkdir($folder_url);
            }
        }
        

        
        // list of permitted file types : pictures and vidoes
        $permitted = array('image/jpeg','image/pjpeg','image/png');
        $result='';
        
        // replace spaces with underscores
        $filename = str_replace(' ', '_', $file['name']);
        // assume filetype is false
        $typeOK = false;
        // check filetype is ok
        foreach($permitted as $type) {
            if($type == $file['type']) {
                $typeOK = true;
                break;
            }
        }
        
        // if file type ok upload the file
        if($typeOK) {
            // switch based on error code
            switch($file['error']) {
                case 0:
                    // create unique filename and upload file
                    ini_set('date.timezone', 'Europe/London');
                    $now = date('Y-m-d-His');
                    $full_url = $folder_url.'/'.$now.$filename;
                    $url = $rel_url.'/'.$now.$filename;
                
                    $success = move_uploaded_file($file['tmp_name'], $url);
                                        // if upload was successful
                    if($success) {
                        // save the url of the file
                        $result['urls'][] = $url;
                        $result['file_type'][] = $file['type'];
                        $result['name'][] = $file['name'];
                        $result['size'][] = $file['size'];
                        $result['file_path'][] = $url;
                    } else {
                        $result['errors'][] = "Error uploaded $filename. Please try again.";
                    }
                    break;
                case 3:
                    // an error occured
                    $result['errors'][] = "Error uploading $filename. Please try again.";
                    break;
                default:
                    // an error occured
                    $result['errors'][] = "System error uploading $filename. Contact webmaster.";
                    break;
            }
        } elseif($file['error'] == 4) {
            // no file was selected for upload
            $result['nofiles'][] = "No file Selected";
        } else {
            // unacceptable file type
            $result['errors'][] = "$filename cannot be uploaded. Acceptable file types: gif, jpg, png.";
        }
        
        return $result;
    } 
 

}