<?php

namespace App\Controller;

use App\Controller\AppController;
use cake\ORM\TableRegistry;
use Cake\Mailer\Email;
use Cake\Auth\DefaultPasswordHasher;
use Cake\Utility\Security;
use Cake\Core\Configure;
use Cake\I18n\Time;
use Cake\Event\Event;

/**
 * Items Controller
 *
 * @property \App\Model\Table\ItemsTable $Items and AutoSparePartsTable $AutoSpareParts
 */
class UsersController extends AppController {

    public function initialize(){
        parent::initialize();
     $this->Auth->allow(['forgotPassword','logout','register','company','changePassword','success','registrationSuccess','activateAccount','passwordChangeRequest']);
    }   

      public function beforeRender(Event $event)
    {
        parent::beforeRender($event);
       
       $this->viewBuilder()->layout('login'); 
    }
   
    public function isAuthorized($user) {

        return true;
    }

 public function index()
    {
      

    }

  
    /**
     * Add method
     *
     * @return \Cake\Http\Response|null Redirects on successful add, renders view otherwise.
     */
  

    public function register(){

    $user = $this->Users->newEntity();
  
        if ($this->request->is('post')) {
             $token = Security::hash(Time::now(), 'sha1', true);

            $this->request->data['token'] = $token;
            
            $user = $this->Users->patchEntity($user, $this->request->getData());
            if ($this->Users->save($user)) {
               return $this->redirect(['action' => 'index',$user->id]);
            }
           $this->Flash->error(__('The user could not be saved. Please, try again.'));
        }

        $this->set(compact('user'));


    }

     public function company($cid=null){

         $company = $this->Companies->newEntity();
       if($cid!==null){
       $c=$this->Companies->find()->where(["user_id"=>$cid]);
        if(empty($c->toArray())){ 
        $user=$this->Users->find()->where(["id"=>$cid])->first();
       
        if ($this->request->is('post')) {
           
            $company = $this->Companies->patchEntity($company, $this->request->getData());
            if ($this->Companies->save($company)) {

                $email = new Email('default');
                        $email->template('authenticate_account','default')
                         ->viewVars([
                            'token' => $user->token, 
                            'fullname' => $user->lastName . ' ' . $user->firstName
                        ])
                        ->emailFormat('html')
                        ->from(['info@bobe.com' => 'BOBE'])
                        ->to($user->email)
                        ->subject(' Account Activation')
                        ->send();
                    
                        return $this->redirect(['action' => 'registrationSuccess']); 
            }
           $this->Flash->error(__('The user could not be saved. Please, try again.'));
        }
       }else{
       throw new Exception("Error Processing Request", 1);
       
       }
        }else{
       throw new Exception("Error Processing Request", 1);
       
       }
        $this->set(compact('company','cid'));

    }

    /**
     * Edit method
     *
     * @param string|null $id User id.
     * @return \Cake\Http\Response|null Redirects on successful edit, renders view otherwise.
     * @throws \Cake\Network\Exception\NotFoundException When record not found.
     */
    public function edit($id = null)
    { 
        $user = $this->Users->get($id, [
            'contain' => []
        ]);
        if ($this->request->is(['patch', 'post', 'put'])) {
            $user = $this->Users->patchEntity($user, $this->request->getData());
            if ($this->Users->save($user)) {
                $this->Flash->success(__('The user has been saved.'));

                return $this->redirect(['action' => 'index']);
            }
            $this->Flash->error(__('The user could not be saved. Please, try again.'));
        }
        $statuses = $this->Users->Statuses->find('list', ['limit' => 200]);
        $registrationStages = $this->Users->RegistrationStages->find('list', ['limit' => 200]);
        $this->set(compact('user', 'statuses', 'registrationStages'));
    }

    /**
     * Delete method
     *
     * @param string|null $id User id.
     * @return \Cake\Http\Response|null Redirects to index.
     * @throws \Cake\Datasource\Exception\RecordNotFoundException When record not found.
     */
    public function delete($id = null)
    {
        $this->request->allowMethod(['post', 'delete']);
        $user = $this->Users->get($id);
        if ($this->Users->delete($user)) {
            $this->Flash->success(__('The user has been deleted.'));
        } else {
            $this->Flash->error(__('The user could not be deleted. Please, try again.'));
        }

        return $this->redirect(['action' => 'index']);
    }

 public function login()
  {
        // $hasher = new DefaultPasswordHasher();
        // echo $hasher->hash('admin1234');
        // exit;
        if ($this->request->is('post')) {
        $this->request->data['email'] = trim($this->request->data['email']);
        $this->request->data['password'] = trim($this->request->data['password']);;
        $user = $this->Auth->identify();

      
        if ($user) {

            if($user['status_id'] == 1){
                    $this->Auth->setUser($user);
                    return $this->redirect($this->Auth->redirectUrl());
                }
                else{
            $this->Flash->error(__('Account is not activated, Please activate your account'));
                }
        }else{
        $this->Flash->error('Your username or password is incorrect.');
    }
  }
}

public function logout()
{
$this->Flash->success('You are now logged out.');

return $this->redirect($this->Auth->logout());
}


 


    function forgotPassword(){ 

          if($this->request->is('post')){        
            // email from the form and retrieve user details
            $user = $this->Users->find('all')->where(['email'=>strtolower($this->request->data['email'])])->first();
         
            if(!empty($user)){
              // Update account and send email to user
                $token=Security::hash( Time::now(),'sha1', true);
                $user->token_pw = $token;
                //$user = $this->Users->patchEntity($user,$this->request->data);
               
    
                if($this->Users->save($user)){ 
                   
                        $title = 'Password Reset Request';
                    // Send the login details to the students email
                      $link='<a href="https://www.seedghana.com/bobe/account/change-password/token/'. $token.'">https://www.seedghana.com/bobe/account/change-password/token/'. $token.'</a>';

                    $email = new Email('default');
                    $email->from(['info@bobe.com' => 'BOBE'])
                        ->to($user->email)
                        ->emailFormat('html')
                        ->subject('Password Reset')
                       ->send('You have requested for a password reset, Please click on this link to change your password <br/>'.$link);
                }

                return $this->redirect(['action' => 'passwordChangeRequest']);
            
            }else{
                $this->Flash->error('The email address you provided is not registered with our system. Thank you');
           
        }  }   

      
    }

    function changePassword($token=null){

        if($this->request->is('post')){
              
            if($this->request->data['new_password'] == $this->request->data['confirm_new_password']){
                             
                    $user = $this->Users->find('all')->where(['token_pw'=>$token])->first();
                    
               
                     if(isset($user)){
                   // $user = $this->Users->get($user->id);
                    $user->password =$this->request->data['new_password'];
                    $user->token_pw =null;
                    if($this->Users->save($user)){
                      $this->Flash->success('Your password has been successfully changed');
                      return $this->redirect(['action' => 'login']);         
                    }
                    }else{
                       throw new NotFoundException;
                    }
                
            }
            else{
                $this->Flash->error('invalid password supplied');
            }
            
        }

         $this->set(compact('token'));
    }

     function passwordChangeRequest(){
    
        $title = 'Password Reset';
                    $msg = 'Your password change request is successful. Please check your email for futher instructions to proceed.';
      
        $this->set(compact('msg', 'title'));
    }

function registrationSuccess(){
    $title= "Registration successfully completed";
       $message="Please click on the link sent to your email to activate your account";
        $this->set(compact('message','title'));
}




 function activateAccount($activate_token = null) {

        $this->log('Activating a users account', 'debug');
        $user = $this->Users->find('all',['conditions'=> ['token' =>$activate_token]])->first(); 
        
        if(is_null($user)){
            $this->log('User is not valid', 'debug');
            return $this->redirect(['controller' => 'Account', 'action' => 'index']);
        }
        $this->log('User is valid', 'debug');
     
      

        $this->log('Activation prerequisite passed', 'debug');
        $Data['token'] = null;
        $Data['status'] = 1;
        $user = $this->Users->patchEntity($user, $Data);     
        if ($this->Users->save($user)) {
              
            $this->Flash->success('Your account has been successfully activated. Please Login.');
            return $this->redirect(['action' => 'login']);
        }
        
        $this->log('Account activation failed', 'debug');
        $this->Flash->error('Your account wasnt activated.');
        return $this->redirect(['action' => 'index']);
    }


    function dashboad() {
 $this->viewBuilder()->layout('account');

       $questionsT = TableRegistry::get('questions');
       $answersT = TableRegistry::get('answers');
       $usersT = TableRegistry::get('users');
       $id=$this->request->session()->read()['Auth']['User']['id'];
        $answers = $answersT->find()->where(['user_id'=>$id]);
         $questions = $questionsT->find('All');
        $i=0;
        foreach($answers as $answer){
          if($answer->correct==true){
            $i++;
          }
        }
        $result=$i;
        if($result>=5) 
          {$resultText="Congratulations";}
        else
          {$resultText="Sorry";};

       // clear the answer table
        $answersT->deleteAll(['user_id' => $id]);
        $user=$this->request->session()->read()['Auth']['User'];
        $company = $this->Companies->find()->where(['user_id'=>$id])->first();

        $this->set(compact('user','answers','questions','result','resultText','company'));  
        
  
  }

   
    }