<?php
namespace App\Controller;

use App\Controller\AppController;
use cake\ORM\TableRegistry;
use Cake\I18n\Time;
use Cake\Event\Event;

/**
 * Items Controller
 *
 * @property \App\Model\Table\ItemsTable $Items and AutoSparePartsTable $AutoSpareParts
 */
class RoomsController extends AppController {
    protected $slug="rooms";

    public function initialize() {
        parent::initialize();        
        $this->paginate = [
            'limit' => 50
        ];
        $this->loadModel('Rooms');
        $this->loadModel('RoomImages');
        $this->loadModel('RoomCategories');
        $this->loadModel('PageRooms');
    }


 public function beforeRender(Event $event) {
        parent::beforeRender($event);
    }

    public function isAuthorized($user) {
        $action = $this->request->params['action'];

        return true;
    }

    /**
     * Index method
     *
     * @return void
     */


    public function index() {
        $pageTitle = 'All Rooms';

          $listings = $this->PageRooms->find('All')->contain(['Rooms.RoomImages','Menus'])->where(['Menus.slug'=>$this->slug]);
         $listings = $this->paginate($listings);
         $this->set(compact('pageTitle', 'listings'));
    }

 public function addContent($id=null) {

    $images=[];
    $tagId="";
        $categories=$this->RoomCategories->find("All")->combine('id','name');
        $product = $this->Rooms->newEntity();        
        if ($this->request->is(['post'])) {
                   
              $product = $this->Rooms->patchEntity($product, $this->request->data);
            
            if ($this->Rooms->save($product)) {

                $pageproduct = $this->PageRooms->newEntity(); 
                // $this->request->data["menu_id"]=$id;
              //$this->request->data['publish_date'] = Time::parseDateTime($this->request->data['publish_date']);
                $this->request->data["room_id"]=$product->id;
                $pc=$this->PageRooms->find('All')->where(["menu_id"=> $this->request->data["menu_id"],"room_id"=>$this->request->data["room_id"]]);
                if(empty($pc->toArray())){
                   $pageproduct = $this->PageRooms->patchEntity($pageproduct, $this->request->data);
                      $this->PageRooms->save($pageproduct);

                }

               $image_field = 'image1';
               if(isset($this->request->data[$image_field])){
                $imageinfo = $this->request->data[$image_field]['tmp_name'] != null ? getimagesize($this->request->data[$image_field]['tmp_name']) : 'temp';
                $fileOK = $this->uploadFiles('../../site/webroot/img/rooms', $this->request->data[$image_field]);
                            if(array_key_exists('urls', $fileOK)) {   
                                                        
                           $this->request->data['image_path'] = substr($fileOK['file_path'][0],29,strlen($fileOK['file_path'][0]));
                            }                
                        }     
            $image = $this->RoomImages->newEntity(); 
            $image = $this->RoomImages->patchEntity($image, $this->request->data);
            $this->RoomImages->save($image);
                        
                $this->Flash->success(__('Product added successfully.'));
                return $this->redirect(['action' => 'pendingContents']);
            } else {
                $this->Flash->error(__('The row could not be save. Try again'));
            }
        } 
        $menu_id=$id;      
        $this->set(compact('product','images','menu_id','categories'));

  }

 
  public function editContent($id=null,$pid=null) {

     $images=[];
    $tagId="";
        $images = $this->RoomImages->find("All")->where(["room_id"=>$pid]); 
        $categories=$this->RoomCategories->find("All")->combine('id','name');
        $product = $this->Rooms->get($pid);        
        if ($this->request->is(['post', 'put', 'patch'])) {
              $this->request->data['status']=2; 
              $this->request->data["room_id"]=$product->id;  
              $product = $this->Rooms->patchEntity($product, $this->request->data);           
            if ($this->Rooms->save($product)) {

           
               $image_field = 'image1';
               if(isset($this->request->data[$image_field])){
                $imageinfo = $this->request->data[$image_field]['tmp_name'] != null ? getimagesize($this->request->data[$image_field]['tmp_name']) : 'temp';
                $fileOK = $this->uploadFiles('../../site/webroot/img/rooms', $this->request->data[$image_field]);
                            if(array_key_exists('urls', $fileOK)) {   
                                                        
                           $this->request->data['image_path'] = substr($fileOK['file_path'][0],29,strlen($fileOK['file_path'][0]));
                            }                
                        }     
            $image = $this->RoomImages->newEntity(); 
            $image = $this->RoomImages->patchEntity($image, $this->request->data);
            $this->RoomImages->save($image);
                        
                $this->Flash->success(__('Product added successfully.'));
                return $this->redirect(['action' => 'pendingContents']);
            } else {
                $this->Flash->error(__('The row could not be save. Try again'));
            }
        } 
        $menu_id=$id;   

        $this->set(compact('product','images','menu_id','categories'));


  }


   public function editMenu($id=null) {

      $menuitem=$this->Menus->find('All')->where(["slug"=>$this->slug])->first();
 
     
           if ($this->request->is(['post', 'put', 'patch'])) {
           
              $menuitem = $this->Menus->patchEntity($menuitem, $this->request->data);
            
            if ($this->Menus->save($menuitem)) {

                        
                $this->Flash->success(__('Menu  item name change successfully.'));
            } else {
                $this->Flash->error(__('The row could not be edited. Try again'));
            }
        }           
        $this->set(compact('menuitem'));



  }

// enable featured
    public function enableContent($id = null) {
        if ($id) {
            $this->Rooms->updateAll(['status' => 1], ['id' => $id]);
            $this->Flash->success(__('Category has been ENABLED successfully.'));
        }

        return $this->redirect($this->referer());
    }

    // disable featured
    public function disableContent($id = null) {
        if ($id) {
            $this->Rooms->updateAll(['status' => 99], ['id' => $id]);
            $this->Flash->success(__('Category has been DISABLED successfully.'));
        }

        return $this->redirect($this->referer());
    }
public function pendingContents($id=null){
         $pageTitle = 'Pending Contents';
  
          $listings = $this->PageRooms->find('All')->contain(['Rooms.RoomImages','Menus'])->where(['Menus.slug'=>$this->slug,'Rooms.status'=>0]);
         $listings = $this->paginate($listings);

         $this->set(compact('pageTitle', 'listings'));
 }


 public function enableContents($id=null){
        $pageTitle = 'Enable Contents';
  
          $listings = $this->PageRooms->find('All')->contain(['Rooms.RoomImages','Menus'])->where(['Menus.slug'=>$this->slug,'Rooms.status'=>1]);
         $listings = $this->paginate($listings);
       
         $this->set(compact('pageTitle', 'listings'));
 }
 
 public function disableContents($id=null){
         $pageTitle = 'Disable Contents';
  
          $listings = $this->PageRooms->find('All')->contain(['Rooms.RoomImages','Menus'])->where(['Menus.slug'=>$this->slug,'Rooms.status'=>99]);
         $listings = $this->paginate($listings);
       
         $this->set(compact('pageTitle', 'listings'));
 }

 public function editedContents($id=null){
          $pageTitle = 'Edited Contents';
  
          $listings = $this->PageRooms->find('All')->contain(['Rooms.RoomImages','Menus'])->where(['Menus.slug'=>$this->slug,'Rooms.status'=>2]);
         $listings = $this->paginate($listings);
       
         $this->set(compact('pageTitle', 'listings'));
 }

 public function featuredContents($id=null){
          $pageTitle = 'featured Rooms';
  
          $listings = $this->PageRooms->find('All')->contain(['Rooms.RoomImages','Menus'])->where(['Menus.slug'=>$this->slug,'Rooms.featured'=>1]);
         $listings = $this->paginate($listings);
       
         $this->set(compact('pageTitle', 'listings'));
 }
public function allContents($id=null){
          $pageTitle = 'All Contents';
  
          $listings = $this->PageRooms->find('All')->contain(['Rooms.RoomImages','Menus'])->where(['Menus.slug'=>$this->slug]);
         $listings = $this->paginate($listings);
       
         $this->set(compact('pageTitle', 'listings'));
 }

  public function uploadFiles($folder, $file, $itemId = null) {
        // setup dir names absolute and relative
        $folder_url = WWW_ROOT.$folder;
        $rel_url = $folder;
        
        // create the folder if it does not exist
        if(!is_dir($folder_url)) {
            mkdir($folder_url);
        }
            
        // if itemId is set create an item folder
        if($itemId) {
            // set new absolute folder
            $folder_url = WWW_ROOT.$folder.'/'.$itemId; 
            // set new relative folder
            $rel_url = $folder.'/'.$itemId;
            // create directory
            if(!is_dir($folder_url)) {
                mkdir($folder_url);
            }
        }
        

        
        // list of permitted file types : pictures and vidoes
        $permitted = array('image/jpeg','image/pjpeg','image/png');
        $result='';
        
        // replace spaces with underscores
        $filename = str_replace(' ', '_', $file['name']);
        // assume filetype is false
        $typeOK = false;
        // check filetype is ok
        foreach($permitted as $type) {
            if($type == $file['type']) {
                $typeOK = true;
                break;
            }
        }
        
        // if file type ok upload the file
        if($typeOK) {
            // switch based on error code
            switch($file['error']) {
                case 0:
                    // create unique filename and upload file
                    ini_set('date.timezone', 'Europe/London');
                    $now = date('Y-m-d-His');
                    $full_url = $folder_url.'/'.$now.$filename;
                    $url = $rel_url.'/'.$now.$filename;
                
                    $success = move_uploaded_file($file['tmp_name'], $url);
                                        // if upload was successful
                    if($success) {
                        // save the url of the file
                        $result['urls'][] = $url;
                        $result['file_type'][] = $file['type'];
                        $result['name'][] = $file['name'];
                        $result['size'][] = $file['size'];
                        $result['file_path'][] = $url;
                    } else {
                        $result['errors'][] = "Error uploaded $filename. Please try again.";
                    }
                    break;
                case 3:
                    // an error occured
                    $result['errors'][] = "Error uploading $filename. Please try again.";
                    break;
                default:
                    // an error occured
                    $result['errors'][] = "System error uploading $filename. Contact webmaster.";
                    break;
            }
        } elseif($file['error'] == 4) {
            // no file was selected for upload
            $result['nofiles'][] = "No file Selected";
        } else {
            // unacceptable file type
            $result['errors'][] = "$filename cannot be uploaded. Acceptable file types: gif, jpg, png.";
        }
        
        return $result;
    } 
 

}