<?php

namespace App\Controller;

use App\Controller\AppController;
use cake\ORM\TableRegistry;
use Cake\Utility\Inflector;
use Cake\I18n\Time;
use Cake\Event\Event;

/**
 * Items Controller
 *
 * @property \App\Model\Table\ItemsTable $Items and AutoSparePartsTable $AutoSpareParts
 */
class AlbumsController extends AppController {

    public function initialize() {
        parent::initialize();
        $this->loadModel('Albums');
         $this->paginate = [
            'limit' => 50
        ];
    }

    public function beforeRender(Event $event)
    {
        parent::beforeRender($event);

    }
   
    public function isAuthorized($user) {

        return true;
    }

    /**
     *
     * @return void
     */
    public function index($action=null) {
         $listings = $this->Albums->find('all');
    

        
         $pageTitle =  "Album";
          $title ="All Album";
        $listings = $this->paginate($listings);
        $this->set(compact('pageTitle', 'listings','title'));
     }

   
  
     public  function add($type = null){
     
       
        $album = $this->Albums->newEntity();
        $parentData = [];
        if ($this->request->is('post')) {
            

            $album = $this->Albums->patchEntity($album, $this->request->data);
           
            if ($this->Albums->save($album)) {

                return $this->redirect(['controller'=>'gallery','action' => 'albums']);
            } else {
                $this->Flash->error(__('The album could not be saved. Please, try again.'));
            }
          
        }
    
        $pageTitle ="Albums";
        $title =" Add album";
       
        $this->set(compact('album','title', 'pageSubTitle','pageTitle'));
     
}


     public  function edit($id=null){

        $album = $this->Albums->get($id);
        $parentData = [];

        if ($this->request->is(['post', 'patch', 'put'])) {
         
          
              $this->request->data['status']=99;
            $album = $this->Albums->patchEntity($album, $this->request->data);
           
          
            if ($this->Albums->save($album)) {

                return $this->redirect(['controller'=>'gallery','action' => 'albums']);
            } else {
                $this->Flash->error(__('The album could not be updated. Please, try again.'));
            }
           
        }

       

        $title='Edit album';
        
        $this->set(compact('album', 'pageTitle','title', 'pageSubTitle','pageTitle'));
     
}



   // enable featured
    public function enable($id = null) {
        if ($id) {
                $this->Albums->updateAll(['status' => 1], ['id' => $id]);
            $this->Flash->success(__('album has been ENABLED successfully.'));
        }

        return $this->redirect($this->referer());
    }

    // disable featured
    public function disable($id = null) {
        if ($id) {
            $this->Albums->updateAll(['status' => 99], ['id' => $id]);
            $this->Flash->success(__('album has been DISABLED successfully.'));
        }
         return $this->redirect($this->referer());
}


}
