<?php
namespace App\Controller;

use App\Controller\AppController;
use cake\ORM\TableRegistry;
use Cake\I18n\Time;
use Cake\Event\Event;

/**
 * Items Controller
 *
 * @property \App\Model\Table\ItemsTable $Items and AutoSparePartsTable $AutoSpareParts
 */
class ContactUsController extends AppController {
     public function initialize() {
        parent::initialize();   
        $this->slug="contact-us"; 
        $this->loadModel('Contacts');
         $this->loadModel('Regions');
         $this->loadModel('Cities');    
        $this->paginate = [
            'limit' => 50
        ];
    }


 public function beforeRender(Event $event) {
        parent::beforeRender($event);

    }

    public function isAuthorized($user) {

        return true;
    }

    /**
     * Index method
     *
     * @return void
     */

  public function index() {
         $this->edit(1);
         $this->render('edit');
    }



 public function add() {
        
        $pageTitle = 'Add Contacts';
    $cmscontacts = $this->Contacts->newEntity();        
        if ($this->request->is(['post'])) {
            $cmscontacts = $this->Contacts->patchEntity($cmscontacts, $this->request->data);
            if ($this->Contacts->save($cmscontacts)) {
                $this->Flash->success(__('news added successfully.'));
                return $this->redirect(['action' => 'pendingListings']);
            } else {
                $this->Flash->error(__('The row could not be save. Try again'));
            }
        }        
        $this->set(compact('pageTitle','cmscontacts', 'cmscatlist','sectionlist'));

  }
  public function edit($id=1) {
    $ob=$this->Contacts->find('All')->where(['id'=>1])->first();
 
        if(!empty($ob)){ 
           $cmscontacts = $this->Contacts->get(1);
           
         }else{
          $cmscontacts = $this->Contacts->newEntity();        
         }

               
        $pageTitle = ' General Contacts';
        if ($this->request->is(['post', 'put', 'patch'])) {
            
            $cmscontacts = $this->Contacts->patchEntity($cmscontacts, $this->request->data);
            if ($this->Contacts->save($cmscontacts)) {
             
                $this->Flash->success(__('Contacts updated successfully.'));
                return $this->redirect(['action' => 'edit']);
            } else {
                $this->Flash->error(__('The row could not be save. Try again'));
            }
        }    

        $this->set(compact('pageTitle','cmscontacts','regions','cities'));   
  }


public function updateCity($id = null)
    {
    $this->autoRender = false;
    $locationT = TableRegistry::get('Cities');
    $location = $locationT->find('list')->where(['region_id'=>$id])->order(['name'=>'ASC']);
    
    $this->response->statusCode(200);
    echo json_encode(array($location));
    $this->log(json_encode(array($location)), 'debug');
    } 
 
}