<?php

namespace App\Controller;

use App\Controller\AppController;
use cake\ORM\TableRegistry;
use Cake\I18n\Time;
use Cake\Event\Event;

/**
 * Items Controller
 *
 * @property \App\Model\Table\ItemsTable $Items and AutoSparePartsTable $AutoSpareParts
 */
class GalleryController extends AppController {
    protected $slug= "gallery";

    public function initialize() {
        parent::initialize();        
        $this->loadModel('Albums');  
        $this->loadModel('Galleries');  
        $this->paginate = ['limit' => 50];
    }

    public function beforeRender(Event $event) {
        parent::beforeRender($event);

    }

    public function isAuthorized($user) {
        $action = $this->request->params['action'];

        return true;
    }

    /**
     * Index method
     *
     * @return void
     */
    public function index() {
        $pageTitle = 'All Images';
        $menu=$this->Menus->find('All')->where(["slug"=>$this->slug])->first();
        $listings = $this->Galleries->find('All')->order(['id'=>'DESC']);
        $listings = $this->paginate($listings);

        $this->set(compact('pageTitle', 'listings'));
    }

    public function view($id=null) {

            
            $cat=$this->Albums->find('All')->where(["id"=>$id])->first();
            $pageTitle = $cat->name;
            $listings = $this->Galleries->find('All')->where(['album_id'=>$id])->order(['id'=>'DESC']);
            $listings = $this->paginate($listings);

            $this->set(compact('pageTitle', 'listings'));
            $this->render('index');
    }
    public function add() {
            
            $albums=$this->Albums->find("All")->combine('id','name'); 
            $uploaded=false;
            $pageTitle = 'Upload Image';
            if ($this->request->is(['post'])) {
        
                foreach ($this->request->data['files'] as $image) {
            
                if(isset($image)){ 
                $cmsbanners = $this->Galleries->newEntity(); 
                
                    $imageinfo = $image['tmp_name'] != null ? getimagesize($image['tmp_name']) : 'temp';
                    $fileOK = $this->uploadImage('../../site/webroot/img/gallery', $image);
                
                                if(array_key_exists('urls', $fileOK)) {                                             
                                    $this->request->data['image_path'] = substr($fileOK['file_path'][0],31,strlen($fileOK['file_path'][0]));

                                $imagename= explode('.', $image['name'])[0];
                                $this->request->data['name']= str_replace(['_','-',':', '\\', '/', '*'], ' ', $imagename);            
                                } 
                            }
            
                $cmsbanners = $this->Galleries->patchEntity($cmsbanners, $this->request->data);
            
                $this->Galleries->save($cmsbanners);
        
                $uploaded=true;
            }

                if ( $uploaded) {

            
                    $this->Flash->success(__('Banner Uploaded successfully.'));
                    return $this->redirect(['action' => 'pendingListings']);
                } else {
                    $this->Flash->error(__('The row could not be save. Try again'));
                }
            }   
        //  $menu=$this->Menus->find('All')->where(["slug"=>$this->slug])->first();
        //  debug($this->slug);exit;
            $menu_id =  "";  
            $this->set(compact('pageTitle','cmsbanners','menu_id','albums'));

    }
    public function overlay() {

            $cmsbanners = $this->Galleries->get(6);  
            $pageTitle = 'Change Bg Overlay Image';
            if ($this->request->is(['post', 'put', 'patch'])) {
            
                $image_field = 'image1';
                if(isset($this->request->data[$image_field])){
                    $imageinfo = $this->request->data[$image_field]['tmp_name'] != null ? getimagesize($this->request->data[$image_field]['tmp_name']) : 'temp';
                    $fileOK = $this->uploadFiles('../../site/webroot/img/gallery', $this->request->data[$image_field]);
                                if(array_key_exists('urls', $fileOK)) {                                             
                                    $this->request->data['image_path'] = substr($fileOK['file_path'][0],31,strlen($fileOK['file_path'][0]));
                
                                } 
                            }
                $this->request->data['status'] = 99;
                $cmsbanners = $this->Galleries->patchEntity($cmsbanners, $this->request->data);
                if ($this->Galleries->save($cmsbanners)) {

                    $this->Flash->success(__('Bg Overlay Image changed successfully.'));
                    return $this->redirect(['controller'=>'Home','action' => 'overlay-image']);
                } else {
                    $this->Flash->error(__('The row could not be save. Try again'));
                }
                } 
    //   debug($cmsbanners);exit;
                
            $this->set(compact('pageTitle','cmsbanners'));   
    }

    public function pendingListings(){
            $pageTitle = 'Pending Images';
            $menu=$this->Menus->find('All')->where(["slug"=>$this->slug])->first();
            $listings = $this->Galleries->find('All')->where(['status'=>0])->order(['id'=>'DESC']);
            $listings = $this->paginate($listings);

            $this->set(compact('pageTitle', 'listings'));
    }

    public function allListings(){
            $pageTitle = 'Pending Images';
            $menu=$this->Menus->find('All')->where(["slug"=>$this->slug])->first();
            $listings = $this->Galleries->find('All')->order(['id'=>'DESC']);
            $listings = $this->paginate($listings);

            $this->set(compact('pageTitle', 'listings'));
    }

    public function enableListings(){

            $pageTitle = 'Enable Images';
            $menu=$this->Menus->find('All')->where(["slug"=>$this->slug])->first();
            $listings = $this->Galleries->find('All')->where(['status'=>1])->order(['id'=>'DESC']);
            $listings = $this->paginate($listings);

            $this->set(compact('pageTitle', 'listings'));
    }

    public function disableListings(){
            $pageTitle = 'Disable Images';
            $menu=$this->Menus->find('All')->where(["slug"=>$this->slug])->first();
            $listings = $this->Galleries->find('All')->where(['status'=>99])->order(['id'=>'DESC']);
            $listings = $this->paginate($listings);

            $this->set(compact('pageTitle', 'listings'));
    }

    public function enable($id=null)
    {
        $this->viewBuilder()->layout(false);
        $banners = $this->Galleries->get($id);


        $this->request->data['status'] = 1;
        $banners = $this->Galleries->patchEntity($banners, $this->request->data);
        if ($this->Galleries->save($banners)) {
        $this->Flash->success(__('Image Enabled'));
        } else {
        $this->Flash->error(__('Error Occurred'));
        }
        
        return $this->redirect($this->referer());
    }


    public function disable($id=null)
    {
        $this->viewBuilder()->layout(false);
        $banners = $this->Galleries->get($id);
        
        $this->request->data['status'] =99;
        $banners = $this->Galleries->patchEntity($banners, $this->request->data);
        if ($this->Galleries->save($banners)) {
        $this->Flash->success(__('Image Disabled'));
        } else {
        $this->Flash->error(__('Error Occurred'));
        }
        
        return $this->redirect($this->referer());
    } 

    public function remove($id=null)
    {
        $this->viewBuilder()->layout(false);
        $banners = $this->Galleries->get($id);
        
        if(file_exists('../../site/webroot/img/gallery/'.$banners->image_path)){
        $this->Galleries->delete($banners);
        unlink('../../site/webroot/img/gallery/'.$banners->image_path);
        $this->Flash->success(__('Image Removed'));
        }else{
        $this->Flash->error(__('Error Occurred'));
        } 
        return $this->redirect($this->referer());
    } 
}