<?php

namespace App\Controller;

use App\Controller\AppController;
use cake\ORM\TableRegistry;
use Cake\I18n\Time;
use Cake\Event\Event;
use Cake\Core\Configure;

/**
 * Items Controller
 *
 * @property \App\Model\Table\ItemsTable $Items and AutoSparePartsTable $AutoSpareParts
 */
class BannersController extends AppController {

    public function initialize() {
        parent::initialize();        
        
        $this->paginate = [
            'limit' => 50
        ];
    }

    public function beforeRender(Event $event) {
        parent::beforeRender($event);
    }

    public function isAuthorized($user) {
        $action = $this->request->params['action'];

        return true;
    }

    /**
     * Index method
     *
     * @return void
     */
    public function index($slug = null) {
        $conditions = [];
        $pageTitle = 'All';

        if($slug == 'pending'){
            $pageTitle = 'Pending';
            $conditions['Banners.status'] = 0;
        }
        else if($slug == 'enabled'){
            $pageTitle = 'Enabled';
            $conditions['Banners.status'] = 1;
        }
        else if($slug == 'disabled'){
            $pageTitle = 'Disabled';
            $conditions['Banners.status'] = 99;
        }
        else if($slug == 'edited'){
            $pageTitle = 'Edited';
            $conditions['Banners.status'] = 2;
        }

        $listings = $this->Banners->find('all')->where($conditions)->order(['Banners.id' => 'DESC']);
        $listings = $this->paginate($listings);

        $this->set(compact('pageTitle', 'listings'));
    }

    public function add() {
        $cmsbanners = $this->Banners->newEntity();  

        $sectionlist = $this->Menus->find('all')->where(['status'=>1]);      
        $pageTitle = 'Add Banner';
        if ($this->request->is(['post'])) {
            $image_field = 'image1';
            if(isset($this->request->data[$image_field])){
                $imageinfo = $this->request->data[$image_field]['tmp_name'] != null ? getimagesize($this->request->data[$image_field]['tmp_name']) : 'temp';
                $fileOK = $this->uploadFiles(Configure::read('IMAGE_PREPATH'), $this->request->data[$image_field], null, null, false);
                
                if(array_key_exists('urls', $fileOK)) {                                             
                    $this->request->data['image_path'] = substr($fileOK['file_path'][0],Configure::read('IMAGE_PRELENGTH'),strlen($fileOK['file_path'][0]));
                } 
            }
        
            $cmsbanners = $this->Banners->patchEntity($cmsbanners, $this->request->data);
            if ($this->Banners->save($cmsbanners)) {

                foreach($sectionlist as $sec){
            $data=[];
            if($this->request->data[$sec->id]==1){
            $cmsbass = $this->SectionBannerAssoc->newEntity();
            $data['section_id']=$sec->id;
            $data['banner_id']=$cmsbanners->id;
            $cmsbass = $this->SectionBannerAssoc->patchEntity($cmsbass, $data);
        $this->SectionBannerAssoc->save($cmsbass);
        }
        }
                $this->Flash->success(__('Banners added successfully.'));
                return $this->redirect(['action' => 'index', 'pending']);
            } else {
                $this->Flash->error(__('The row could not be save. Try again'));
            }
        }        
        $this->set(compact('pageTitle','cmsbanners', 'cmscatlist','sectionlist'));

    }

public function edit($id) {

        $cmsbanners = $this->Banners->get($id);  
        $sectionlist = $this->Menus->find('all')->where(['status'=>1]);            
        $pageTitle = 'Edit Banners';
        if ($this->request->is(['post', 'put', 'patch'])) {

        $this->SectionBannerAssoc->deleteAll(['banner_id'=>$id]);
            $image_field = 'image1';
            if(isset($this->request->data[$image_field])){
                $imageinfo = $this->request->data[$image_field]['tmp_name'] != null ? getimagesize($this->request->data[$image_field]['tmp_name']) : 'temp';
                $fileOK = $this->uploadFiles(Configure::read('IMAGE_PREPATH'), $this->request->data[$image_field], null, null, false);
                            if(array_key_exists('urls', $fileOK)) {                                             
                                $this->request->data['image_path'] = substr($fileOK['file_path'][0],Configure::read('IMAGE_PRELENGTH'),strlen($fileOK['file_path'][0]));
            
                            } 
                        }
            $this->request->data['status'] = 2;
            $cmsbanners = $this->Banners->patchEntity($cmsbanners, $this->request->data);
            if ($this->Banners->save($cmsbanners)) {


                foreach($sectionlist as $sec){
            $data=[];
            if($this->request->data[$sec->id]==1){
            $cmsbass = $this->SectionBannerAssoc->newEntity();
            $data['section_id']=$sec->id;
            $data['banner_id']=$cmsbanners->id;
            $cmsbass = $this->SectionBannerAssoc->patchEntity($cmsbass, $data);
        $this->SectionBannerAssoc->save($cmsbass);
        }
}

                $this->Flash->success(__('banners added successfully.'));
                return $this->redirect(['action' => 'index', 'edited']);
            } else {
                $this->Flash->error(__('The row could not be save. Try again'));
            }
        }        
        $this->set(compact('pageTitle','cmsbanners', 'cmscatlist','sectionlist'));   
}


public function pendingListings(){
        $pageTitle = 'Pending Banners';
        $llistings = $this->Banners->find('all')->where(['status' =>0]);
        $listings = $this->paginate($llistings);
        $this->set(compact('pageTitle', 'listings'));
}

public function enableListings(){
        $pageTitle = 'Enable Banners';

        $llistings = $this->Banners->find('all')->where(['status' =>1]);
        $listings = $this->paginate($llistings);
        $this->set(compact('pageTitle', 'listings'));
}
public function disableListings(){
        $pageTitle = 'Disable Banners';
        $llistings = $this->Banners->find('all')->where(['status' =>99]);
        $listings = $this->paginate($llistings);
        $this->set(compact('pageTitle', 'listings'));
}

public function editedListings(){
        $pageTitle = 'Edited Banners';
        $llistings = $this->Banners->find('all')->where(['status' =>2]);
        $listings = $this->paginate($llistings);
        $this->set(compact('pageTitle', 'listings'));
}

public function enable($id=null)
{
    $this->viewBuilder()->layout(false);
    $banners = $this->Banners->get($id);


    $this->request->data['status'] = 1;
    $banners = $this->Banners->patchEntity($banners, $this->request->data);
    if ($this->Banners->save($banners)) {
    $this->Flash->success(__('banners Enabled'));
    } else {
    $this->Flash->error(__('Error Occurred'));
    }
    
    return $this->redirect($this->referer());
}


public function disable($id=null)
{
    $this->viewBuilder()->layout(false);
    $banners = $this->Banners->get($id);
    
    $this->request->data['status'] =99;
    $banners = $this->Banners->patchEntity($banners, $this->request->data);
    if ($this->Banners->save($banners)) {
    $this->Flash->success(__('banners Disabled'));
    } else {
    $this->Flash->error(__('Error Occurred'));
    }
    
    return $this->redirect($this->referer());
} 

}