<?php

namespace App\Controller;

use App\Controller\AppController;
use cake\ORM\TableRegistry;
use Cake\Utility\Inflector;
use Cake\I18n\Time;
use Cake\Event\Event;

/**
 * Items Controller
 *
 * @property \App\Model\Table\ItemsTable $Items and AutoSparePartsTable $AutoSpareParts
 */
class CategoriesController extends AppController {

    public function initialize() {
        parent::initialize();
        $this->loadModel('ProductCategories');
         $this->paginate = [
            'limit' => 50
        ];
    }

    public function beforeRender(Event $event)
    {
        parent::beforeRender($event);

    }
   
    public function isAuthorized($user) {

        return true;
    }

    /**
     *
     * @return void
     */
    public function index($action=null) {
      if (isset($this->request->query['search'])) {

            $listings = $this->ProductCategories->searchCategories(1,$this->request->query['search']);
            $pageTitle = "All Listings";
        } else {
            $listings = $this->ProductCategories->getAllCategories();
        }

        $pageTitle =" Categories";
        $listings = $this->paginate($listings);
        $this->set(compact('pageTitle', 'listings'));
        $this->render('category-listings');
     }

    public function categories() {
      
        if (isset($this->request->query['search'])) {

            $listings = $this->ItemCategories->searchCategories(1,$this->request->query['search']);
            $pageTitle = "All Listings";
        } else {
            $listings = $this->ProductCategories->getAllCategories();
        }

        $pageTitle =" Categories";
        $listings = $this->paginate($listings);
        $this->set(compact('pageTitle', 'listings'));
        $this->render('category-listings');
    }

public function viewAllCategories(){
    $this->categories();
}

 public function subCategories() {
        if (isset($this->request->query['search'])) {

            $listings = $this->ProductCategories->searchSubCategories($section,$this->request->query['search']);
            $pageTitle = "All Listings";
        } else {
            $listings = $this->ProductCategories->getAllSubCategories();
        }
 

        $categories = $this->ProductCategories->getCategories();
        $pageTitle =  "Sub Categories";
        $listings = $this->paginate($listings);
        $this->set(compact('pageTitle', 'listings','categories'));
         $this->render('sub-category-listings');
    }
public function viewAllSubCategories(){
    $this->subCategories();
}

public function viewSectionCategories($id=null){

        $listings = $this->ProductCategories->sectionCategories($id); 

        $pageTitle =" Categories";
        $listings = $this->paginate($listings);
        $this->set(compact('pageTitle', 'listings'));
        $this->render('category-listings');
}
public function viewSectionSubCategories($id=null){

        $listings = $this->ProductCategories->updateSubCategories($id); 

        $pageTitle ="Sub Categories";
        $listings = $this->paginate($listings);
        $this->set(compact('pageTitle', 'listings'));
        $this->render('sub-category-listings');
}
public function viewSectionSubSubCategories($id=null){

        $listings = $this->ProductCategories->updateSubCategories($id); 

        $pageTitle ="Sub Sub Categories";
        $listings = $this->paginate($listings);
        $this->set(compact('pageTitle', 'listings'));
        $this->render('sub-sub-category-listings');
}
     public function subSubCategories() {
       
       if (isset($this->request->query['search'])) {

            $listings = $this->ProductCategories->searchSubSubCategories($section,$this->request->query['search']);
            $pageTitle = "All Listings";
        } else {
            $listings = $this->ProductCategories->getAllSubSubCategories();
        }
$categories = $this->ProductCategories->getCategories();
        $pageTitle = " Sub Sub Categories";
        $listings = $this->paginate($listings);
        $this->set(compact('pageTitle', 'listings','categories'));
         $this->render('sub-sub-category-listings');
    }
public function viewAllSubSubCategories(){
    $this->subSubCategories();
}
     public  function addCategory($type = null){
     
       
        $category = $this->ProductCategories->newEntity();
        $parentData = [];
        if ($this->request->is('post')) {
            
             $this->request->data['slug'] = Inflector::slug($this->request->data['name']);       

            $category = $this->ProductCategories->patchEntity($category, $this->request->data);
            if(empty($this->ProductCategories->getCategoryFromName($this->request->data['name']))){
            if ($this->ProductCategories->save($category)) {

                return $this->redirect(['action' => 'categories']);
            } else {
                $this->Flash->error(__('The category could not be saved. Please, try again.'));
            }
          }else{
            $this->Flash->error(__('The category name is already used.'));
          }
        }
    
        $pageSubTitle=' Category';
         $pageTitle =  "Categories";
        $this->set(compact('category', 'pageSubTitle','pageTitle'));
     
}


     public  function editCategory($pid =null, $id=null){
     
       
        $category = $this->ProductCategories->get($id);
        $parentData = [];

        if ($this->request->is(['post', 'patch', 'put'])) {
         
          
            $this->request->data['slug'] = Inflector::slug($this->request->data['name']);    
 
            $category = $this->ProductCategories->patchEntity($category, $this->request->data);

           if(empty($this->ProductCategories->getCategoryFromName($this->request->data['name']))){
            if ($this->ProductCategories->save($category)) {

                return $this->redirect(['action' => 'categories']);
            } else {
                $this->Flash->error(__('The category could not be updated. Please, try again.'));
            }
            }else{
            $this->Flash->error(__('The category name is already used.'));
          }
        }

       

        $pageSubTitle=' Category';
         $pageTitle =  "Categories";
        $this->set(compact('category', 'pageTitle', 'pageSubTitle','pageTitle'));
     
}

 public  function addSubCategory($id = null, $type = null){
      
        $categoryDetails = [];
        $pageTitle = '';
        if (!empty($id)) {
            $categoryDetails = $this->ProductCategories->get($id);
            $pageTitle = ucwords(str_replace('-', ' ', $categoryDetails->name));
        }

        $category = $this->ProductCategories->newEntity();
        $parentData = [];
        if ($this->request->is('post')) {
         
        
         $countSubCat=$this->ProductCategories->getSubCategoriesFromName0($this->request->data['name']);
         $ps=($countSubCat>=1)?'-'.$countSubCat:'';
         $this->request->data['slug'] = Inflector::slug($this->request->data['name']).$ps;    
             $category = $this->ProductCategories->patchEntity($category, $this->request->data);

            if(empty($this->ProductCategories->getSubCategoriesFromName($this->request->data['name'],$this->request->data['parent_category_id']))){
            if ($this->ProductCategories->save($category)) {

                return $this->redirect(['action' => 'subCategories']);
            } else {
                $this->Flash->error(__('The category could not be saved. Please, try again.'));
            }}else{
               $this->Flash->error(__('The category name is already used.'));  
            }
        }

         $sectionQuery = $this->ProductCategories->updateSubCategories(0);
        $parentSections = [];
        foreach ($sectionQuery as $key=>$q ) {
            if(!empty($q))
            $parentSections[$key] = $q;
        }
        $level=0;
        $pageSubTitle='Sub Category';
        $this->set(compact('parentSections', 'category', 'level', 'categoryDetails', 'pageTitle', 'pageSubTitle'));
     
}

public  function editSubCategory($pid = null, $id = null){
        $section='autos';

        $categoryDetails = [];
        $pageTitle = '';

        $category = $this->ProductCategories->get($id);
     
        if ($this->request->is(['post', 'patch', 'put'])) {

            $countSubCat=$this->ProductCategories->getSubCategoriesFromName0($this->request->data['name']);
         $ps=($countSubCat>=1)?'-'.$countSubCat:'';
         $this->request->data['slug'] = Inflector::slug($this->request->data['name']).$ps;   
     
       if(empty($this->ProductCategories->getSubCategoriesFromName($this->request->data['name'],$this->request->data['parent_category_id']))){
            $category = $this->ProductCategories->patchEntity($category, $this->request->data);

            if ($this->ProductCategories->save($category)) {

                return $this->redirect(['action' => 'subCategories']);
            } else {
                $this->Flash->error(__('The category could not be saved. Please, try again.'));
            }}else{
               $this->Flash->error(__('The category name is already used.'));  
            }
        }

         $sectionQuery = $this->ProductCategories->updateSubCategories(0);
       $parentSections = [];
        foreach ($sectionQuery as $key=>$q ) {
            if(!empty($q))
            $parentSections[$key] = $q;
        }
        
        $level=0;
        $pageSubTitle='Sub Category';
        $this->set(compact('parentSections', 'category', 'level', 'pageTitle', 'pageSubTitle'));
     
}

public  function addSubSubCategory($id = null, $type = null){
        $selected = $id;
        $categoryDetails = [];
        $pageTitle = '';
        if (!empty($id)) {
            $categoryDetails = $this->ProductCategories->get($id);
            $pageTitle = ucwords(str_replace('-', ' ', $categoryDetails->name));
        }

        $category = $this->ProductCategories->newEntity();
        $parentData = [];
        if ($this->request->is('post')) {
           $countSubCat=$this->ProductCategories->getSubCategoriesFromName0($this->request->data['name']);
         $ps=($countSubCat>=1)?'-'.$countSubCat:'';
         $this->request->data['slug'] = Inflector::slug($this->request->data['name']).$ps;   
     
            $category = $this->ProductCategories->patchEntity($category, $this->request->data);

 if(empty($this->ProductCategories->getSubCategoriesFromName($this->request->data['name'],$this->request->data['parent_category_id']))){
       
            if ($this->ProductCategories->save($category)) {

                return $this->redirect(['action' => 'subSubCategories']);
            } else {
                $this->Flash->error(__('The sub sub category could not be saved. Please, try again.'));
            }}else{
               $this->Flash->error(__('The category name is already used.'));  
            }
        }

        $sectionQuery = $this->ProductCategories->updateSubCategories(0);
  
        $parentSections = [];
        foreach ($sectionQuery as $key=>$q ) {
            if(!empty($q))
            $parentSections[$key] = $q;
        }
    
        $level=0;
        $pageSubTitle='Sub Sub Category';
        $this->set(compact('parentSections', 'category', 'level', 'categoryDetails', 'pageTitle', 'pageSubTitle'));
     
}


public  function editSubSubCategory($pid = null, $id = null){
        $pageTitle = '';
     
        $category = $this->ProductCategories->get($id);
      
         if ($this->request->is(['post', 'patch', 'put'])) {
     $countSubCat=$this->ProductCategories->getSubCategoriesFromName0($this->request->data['name']);
         $ps=($countSubCat>=1)?'-'.$countSubCat:'';
         $this->request->data['slug'] = Inflector::slug($this->request->data['name']).$ps;   
               
       
            $category = $this->ProductCategories->patchEntity($category, $this->request->data);

 if(empty($this->ProductCategories->getSubCategoriesFromName($this->request->data['name'],$this->request->data['parent_category_id']))){

       
            if ($this->ProductCategories->save($category)) {

                return $this->redirect(['action' => 'subSubCategories']);
            } else {
                $this->Flash->error(__('The sub sub category could not be saved. Please, try again.'));
            }}else{
               $this->Flash->error(__('The category name is already used.'));  
            }
        }

         $sectionQuery = $this->ProductCategories->updateSubCategories(0);
       $parentSections = [];
        foreach ($sectionQuery as $key=>$q ) {
            if(!empty($q))
            $parentSections[$key] = $q;
        }
 
        $level=0;
        $pageSubTitle='Sub Sub Category';
        $this->set(compact('parentSections', 'category', 'level', 'pageTitle', 'pageSubTitle'));
     
}




 public function updateSubCategories($id = null)
    {
        $this->autoRender = false;

        $subCategories = $this->ProductCategories->updateSubCategories($id);
     
        $this->response->statusCode(200);
        echo json_encode(array($subCategories));
        $this->log(json_encode(array($subCategories)), 'debug');
    } 

   // enable featured
    public function enableCategory($id = null) {
        if ($id) {
            $this->ProductCategories->enableCategory($id);
            $this->Flash->success(__('Category has been ENABLED successfully.'));
        }

        return $this->redirect($this->referer());
    }

    // disable featured
    public function disableCategory($id = null) {
        if ($id) {
            $this->ProductCategories->disableCategory($id);
            $this->Flash->success(__('Category has been DISABLED successfully.'));
        }

        return $this->redirect($this->referer());
    }

   

}
