<?php
namespace App\Model\Entity;

use Cake\ORM\Entity;

/**
 * ProductLine Entity
 *
 * @property int $id
 * @property string $name
 * @property string $description
 * @property int $quantity
 * @property int $viewed
 * @property \Cake\I18n\FrozenTime $featured_start_date
 * @property \Cake\I18n\FrozenTime $featured_end_date
 * @property int $status
 * @property float $price
 * @property int $featured
 * @property int $category_id
 * @property string $product_code
 * @property int $product_brand_id
 *
 * @property \App\Model\Entity\Category $category
 * @property \App\Model\Entity\ProductBrand $product_brand
 * @property \App\Model\Entity\Product[] $products
 * @property \App\Model\Entity\SalesOrderLine[] $sales_order_lines
 */
class ProductLine extends Entity
{

    /**
     * Fields that can be mass assigned using newEntity() or patchEntity().
     *
     * Note that when '*' is set to true, this allows all unspecified fields to
     * be mass assigned. For security purposes, it is advised to set '*' to false
     * (or remove it), and explicitly make individual fields accessible as needed.
     *
     * @var array
     */
    protected $_accessible = [
        'name' => true,
        'description' => true,
        'quantity' => true,
        'viewed' => true,
        'featured_start_date' => true,
        'featured_end_date' => true,
        'status' => true,
        'price' => true,
        'featured' => true,
        'category_id' => true,
        'product_code' => true,
        'product_brand_id' => true,
        'category' => true,
        'product_brand' => true,
        'products' => true,
        'sales_order_lines' => true
    ];
}
