<?php
declare(strict_types=1);

namespace App\Controller;

use App\Controller\AppController;
use cake\ORM\TableRegistry;
use Cake\Mailer\Email;
use Cake\Auth\DefaultPasswordHasher;
use Cake\Utility\Security;
use Cake\Core\Configure;
use Cake\I18n\Time;
use Cake\Event\Event;
use Cake\View\Helper\FormHelper;

/**
 * Users Controller
 *
 * @property \App\Model\Table\UsersTable $Users
 * @method \App\Model\Entity\User[]|\Cake\Datasource\ResultSetInterface paginate($object = null, array $settings = [])
 */
class UsersController extends AppController
{

   public function initialize()
   {
      parent::initialize();
      $this->loadModel('Users');
   }

   
    public function register(){

     if ($this->request->is('post')) {
        
             $user = $this->Users->newEntity();
  
        if ($this->request->is('post')) {
             $token = Security::hash(Time::now(), 'sha1', true);

            $this->request->data['token'] = $token;
            
            $user = $this->Users->patchEntity($user, $this->request->getData());


            $image = $this->request->getUploadedFile('image_file');

            $email = $this->request->getUploadedFile('email');

            echo $email;


            $name = $image->getClientFilename();
          
            $targetPath = WWW_ROOT.'img'.DS. $name;

            if($name)
            $image->moveTo($targetPath);

            $user->image_path =  $name;


            if ($this->Users->save($user)) {
               // return $this->redirect(['action' => 'index',$user->id]);
               return $this->redirect(['controller' => 'User', 'action' => 'address']); exit();

            }
           $this->Flash->error(__('The user could not be saved. Please, try again.'));
        }

        $_SESSION['userEmail'] = $user->email;
        $this->set(compact('user'));
          
     }

}

public function addContacts($user_id=null)
{
}

    public function address(){

      $userEmail = $_SESSION['userEmail'];

      $Users = $this->Users->find('all', [
			'conditions' => [
				'email' => $userEmail,
			]
		]);

        if($this->request->is('post')){
         $officePhone = $this->request->getdata('officePhone');
         $homePhone = $this->request->getdata('homePhone');
         $businessAddress = $this->request->getdata('businessAddress');
         $homeAddress = $this->request->getdata('homeAddress');
         $userId = $this->request->getdata('userId');

         $user_contactsTable = TableRegistry::get('user_contacts ');

         $user_contacts = $user_contactsTable ->newEntity();

         $user_contacts->office_phone = $officePhone;
         $user_contacts->business_address = $businessAddress;
         $user_contacts->mobile_phone= $homePhone;
         $user_contacts->home_address = $homeAddress;
         $user_contacts->user_id = $userId;


         if ($user_contactsTable->save($user_contacts)) { 

            return $this->redirect(['controller' => 'User', 'action' => 'education']); exit();

         }

        } 

        $this->set(compact('Users'));

   }

   public function education(){

      $userEmail = $_SESSION['userEmail'];

      $Users = $this->Users->find('all', [
			'conditions' => [
				'email' => $userEmail,
			]
		]);

      if($this->request->is('post')){
         $levelOfEducation = $this->request->getdata('levelOfEducation');
         $certificate = $this->request->getdata('certificate');
         $institution = $this->request->getdata('institution');
         $institutionAddress = $this->request->getdata('institutionAddress');
         $continuingEducation = $this->request->getdata('continuingEducation');
         $country = $this->request->getdata('country');
         $userId = $this->request->getdata('userId');

         $user_educationsTable = TableRegistry::get('user_educations');

         $user_educations = $user_educationsTable ->newEntity();

         $user_educations->level = $levelOfEducation;
         $user_educations->institution = $institution;
         $user_educations->institution_address = $institutionAddress;
         // $user_educations->country_id = $country;
         $user_educations->qualification = $certificate;
         $user_educations->continue_edu_course = $continuingEducation;
         $user_educations->user_id = $userId;


         if ($user_educationsTable->save($user_educations)) { 
            return $this->redirect(['controller' => 'User', 'action' => 'professionalInformation']); exit();
         }
      }

      $this->set(compact('Users'));


   }


   public function professionalInformation(){

      $userEmail = $_SESSION['userEmail'];

      $Users = $this->Users->find('all', [
			'conditions' => [
				'email' => $userEmail,
			]
		]);

      if($this->request->is('post')){
         $employment = $this->request->getdata('employment');
         $currentPositionTitle = $this->request->getdata('currentPositionTitle');
         $positionDuration = $this->request->getdata('positionDuration');
         $userId = $this->request->getdata('userId');


         $user_employment_expertisesTable = TableRegistry::get('user_employment_expertises');

         $user_employment = $user_employment_expertisesTable->newEntity();

         $user_employment->current_place_of_employment = $employment;
         $user_employment->current_position_title = $currentPositionTitle;
         $user_employment->current_position_duration =  $positionDuration;
         $user_employment->user_id =  $userId;


         if ($user_employment_expertisesTable->save($user_employment)) { 
            return $this->redirect(['controller' => 'User', 'action' => 'paymentInformation']); exit();
         }
      }

      $this->set(compact('Users'));

   }
   
   public function paymentInformation(){

      $userEmail = $_SESSION['userEmail'];

      $Users = $this->Users->find('all', [
			'conditions' => [
				'email' => $userEmail,
			]
		]);

      if($this->request->is('post')){

         $paymentMethod = $this->request->getdata('paymentMethod');
         $userId = $this->request->getdata('userId');


         $user_payment_detailsTable = TableRegistry::get('user_payment_details');

         $payment_details = $user_payment_detailsTable->newEntity();

         $payment_details->registration_fee_amount = 100;
         $payment_details->annual_dues = 300;
         $payment_details->total_amount_due	= 400;
         $payment_details->payment_method = $paymentMethod;
         $payment_details->user_id	= $userId;


         if ($user_payment_detailsTable->save($payment_details)) { 
            // echo 'save';
            return $this->redirect(['controller' => 'User', 'action' => 'finish']); exit();
         }

      }
      $this->set(compact('Users'));
   }

   public function finish(){ 

   }



}