<?php
namespace App\Model\Table;

use Cake\ORM\Query;
use Cake\ORM\RulesChecker;
use Cake\ORM\Table;
use Cake\Validation\Validator;

/**
 * Menus Model
 *
 * @property \App\Model\Table\ParentMenusTable|\Cake\ORM\Association\BelongsTo $ParentMenus
 * @property \App\Model\Table\PageContentsTable|\Cake\ORM\Association\HasMany $PageContents
 * @property \App\Model\Table\PageProductsTable|\Cake\ORM\Association\HasMany $PageProducts
 * @property \App\Model\Table\PageRoomsTable|\Cake\ORM\Association\HasMany $PageRooms
 *
 * @method \App\Model\Entity\Menu get($primaryKey, $options = [])
 * @method \App\Model\Entity\Menu newEntity($data = null, array $options = [])
 * @method \App\Model\Entity\Menu[] newEntities(array $data, array $options = [])
 * @method \App\Model\Entity\Menu|bool save(\Cake\Datasource\EntityInterface $entity, $options = [])
 * @method \App\Model\Entity\Menu saveOrFail(\Cake\Datasource\EntityInterface $entity, $options = [])
 * @method \App\Model\Entity\Menu patchEntity(\Cake\Datasource\EntityInterface $entity, array $data, array $options = [])
 * @method \App\Model\Entity\Menu[] patchEntities($entities, array $data, array $options = [])
 * @method \App\Model\Entity\Menu findOrCreate($search, callable $callback = null, $options = [])
 */
class MenusTable extends Table
{
    /**
     * Initialize method
     *
     * @param array $config The configuration for the Table.
     * @return void
     */
    public function initialize(array $config)
    {
        parent::initialize($config);

        $this->setTable('menus');
        $this->setDisplayField('name');
        $this->setPrimaryKey('id');

        $this->belongsTo('ParentMenus', [
            'foreignKey' => 'parent_menu_id',
            'className' => 'Menus'
        ]);
        $this->hasMany('ChildMenus', [
            'foreignKey' => 'parent_menu_id',
            'className' => 'Menus',
            'conditions' => [
                'ChildMenus.status' => 1
            ]
        ]);
        $this->hasMany('PageContents', [
            'foreignKey' => 'menu_id'
        ]);
    }
}
