<?php
/**
 * CakePHP(tm) : Rapid Development Framework (https://cakephp.org)
 * Copyright (c) Cake Software Foundation, Inc. (https://cakefoundation.org)
 *
 * Licensed under The MIT License
 * For full copyright and license information, please see the LICENSE.txt
 * Redistributions of files must retain the above copyright notice.
 *
 * @copyright     Copyright (c) Cake Software Foundation, Inc. (https://cakefoundation.org)
 * @link          https://cakephp.org CakePHP(tm) Project
 * @since         0.10.0
 * @license       https://opensource.org/licenses/mit-license.php MIT License
 */
?>
<!DOCTYPE html>
<html>
	<head>
		<?= $this->Html->charset() ?>
		<meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">
		<title>
			<?= isset($appSettings['SITE-NAME']) ? $appSettings['SITE-NAME'] : 'Website' ?>
			<?= isset($appSettings['SITE-DESCRIPTION']) ? $appSettings['SITE-DESCRIPTION'] : '' ?>
		</title>
		<?= $this->Html->meta('icon') ?>

		<?= $this->Html->css('theme.css') ?>
		<?= $this->Html->css('media.css') ?>
		<?= $this->Html->css('font-awesome.min.css') ?>


		<?= $this->fetch('meta') ?>
		<?= $this->fetch('css') ?>
		<?= $this->fetch('script') ?>
	</head>
	<body>

		<div class="DesignHolder">
			<div class="LayoutFrame">

				<?= $this->element('menus/main_menu1') ?>

				<?= $this->fetch('content') ?>

			</div>
		</div>

		<div id="loader-wrapper">
			<div id="loader"></div>

			<div class="loader-section section-left"></div>
			<div class="loader-section section-right"></div>
		</div>

		<?= $this->Html->script('jquery-1.11.0.min.js') ?>
		<?= $this->Html->script('jquery.sudoSlider.min.js') ?>
		<?= $this->Html->script('global.js') ?>
		<?= $this->Html->script('modernizr.js') ?>

	</body>
</html>