<?php
/**
 * CakePHP(tm) : Rapid Development Framework (https://cakephp.org)
 * Copyright (c) Cake Software Foundation, Inc. (https://cakefoundation.org)
 *
 * Licensed under The MIT License
 * For full copyright and license information, please see the LICENSE.txt
 * Redistributions of files must retain the above copyright notice.
 *
 * @copyright     Copyright (c) Cake Software Foundation, Inc. (https://cakefoundation.org)
 * @link          https://cakephp.org CakePHP(tm) Project
 * @since         0.10.0
 * @license       https://opensource.org/licenses/mit-license.php MIT License
 */
?>
<!DOCTYPE html>
<html>
	<head>
		<?= $this->Html->charset() ?>
		<meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">
		<title>
			<?= isset($appSettings['SITE-NAME']) ? $appSettings['SITE-NAME'] : 'Website' ?>
			<?= isset($appSettings['SITE-DESCRIPTION']) ? $appSettings['SITE-DESCRIPTION'] : '' ?>
		</title>
		<?= $this->Html->meta('icon') ?>

		<!-- Vendor CSS Files -->
		<?= $this->Html->css('../assets/vendor/bootstrap/css/bootstrap.min.css') ?>
		<?= $this->Html->css('../assets/vendor/icofont/icofont.min.css') ?>
		<?= $this->Html->css('../assets/vendor/boxicons/css/boxicons.min.css') ?>
		<?= $this->Html->css('../assets/vendor/animate.css/animate.min.css') ?>
		<?= $this->Html->css('../assets/vendor/venobox/venobox.css') ?>
		<?= $this->Html->css('../assets/vendor/aos/aos.css') ?>
		<?= $this->Html->css('../assets/css/style.css') ?>
		
		<?= $this->Html->css('blue_theme.css') ?>

		<?= $this->fetch('meta') ?>
		<?= $this->fetch('css') ?>
		<?= $this->fetch('script') ?>
	</head>
	
	<body>
		
		<?= $this->element('menus/main_menu2') ?>

		<?= $this->fetch('content') ?>

		<a href="#" class="back-to-top"><i class="icofont-simple-up"></i></a>

		<?= $this->Html->script('../assets/vendor/jquery/jquery.min.js') ?>
		<?= $this->Html->script('../assets/vendor/bootstrap/js/bootstrap.bundle.min.js') ?>
		<?= $this->Html->script('../assets/vendor/jquery.easing/jquery.easing.min.js') ?>
		<?= $this->Html->script('../assets/vendor/php-email-form/validate.js') ?>
		<?= $this->Html->script('../assets/vendor/jquery-sticky/jquery.sticky.js') ?>
		<?= $this->Html->script('../assets/vendor/venobox/venobox.min.js') ?>
		<?= $this->Html->script('../assets/vendor/waypoints/jquery.waypoints.min.js') ?>
		<?= $this->Html->script('../assets/vendor/counterup/counterup.min.js') ?>
		<?= $this->Html->script('../assets/vendor/isotope-layout/isotope.pkgd.min.js') ?>
		<?= $this->Html->script('../assets/vendor/aos/aos.js') ?>
		<?= $this->Html->script('../assets/js/main.js') ?>
		
	</body>
</html>