<?php
/**
 * CakePHP(tm) : Rapid Development Framework (https://cakephp.org)
 * Copyright (c) Cake Software Foundation, Inc. (https://cakefoundation.org)
 *
 * Licensed under The MIT License
 * For full copyright and license information, please see the LICENSE.txt
 * Redistributions of files must retain the above copyright notice.
 *
 * @copyright Copyright (c) Cake Software Foundation, Inc. (https://cakefoundation.org)
 * @link      https://cakephp.org CakePHP(tm) Project
 * @since     0.2.9
 * @license   https://opensource.org/licenses/mit-license.php MIT License
 */
namespace App\Controller;

use Cake\Http\Exception\NotFoundException;
use Cake\Mailer\Email;
/**
 * Static contact us controller
 *
 * This controller will render views from Template/AboutUs/
 *
 */
class ContactUsController extends ContentController
{
	/**
     * Initialization hook method.
     *
     * Use this method to add common initialization code like loading components.
     *
     * e.g. `$this->loadComponent('Security');`
     *
     * @return void
     */
    public function initialize()
    {
        parent::initialize();
		
        $this->loadModel('Contacts');
    }
	
    public function index()
    {
		// Loading content and basic processes to load the content has been implemented in the content
		// All we need to do is set the section to the correct slug for this controller
		// So lets just call the parent method
		$this->request->params['section'] = 'contact-us';
		parent::index();
						
		// Process form, Contact us form from the page
		if ($this->request->is('post')) {
			$this->processForm('Feedbacks', 'Customer Feedback', $this->request->getData());
		}
		
		// Load the contact details
		// We will need this for the contact us section
		$contactDetails = $this->Contacts->find('All')->first();
		
		$this->set(compact('contactDetails'));
    }

    public function sendMessage(){
      if ($this->request->is('post')) {
        $title = 'Enter Site - Feedback Form';
               // Send the login details to the students email
             $message= "From ".$this->request->data['name']."
             <br/>Email :".$this->request->data['email']."
             <br/>Telephone :".$this->request->data['phone']."
             <br/>Subject :".$this->request->data['subject']."
             <br/>Message<br/>".$this->request->data['message'];

               $email = new Email();
               $email->transport('default');
               $email->from([$this->request->data['email'] => $this->request->data['name']])
                  //  ->to('evelyn.wemegah@accolm.com')
                   ->to('aminatu.yusif@accolm.com')
                   ->emailFormat('html')
                  //  ->subject($this->request->data['subject'])
                  ->subject('Enter Site - Feedback Form')
                  ->send($message);
         
           $this->Flash->success(__('The message has been sent successfully'));
       }else{
           $this->Flash->error(__('Error occurred processing the form. Please, try again.'));
       }
   

   return $this->redirect($this->referer());
       
      

    }
}
