<?php
namespace App\Model\Entity;

use Cake\ORM\Entity;

/**
 * Menu Entity
 *
 * @property int $id
 * @property string $name
 * @property string|null $description
 * @property int $parent_menu_id
 * @property int $status
 * @property string $slug
 * @property int|null $order_key
 *
 * @property \App\Model\Entity\ParentMenu $parent_menu
 * @property \App\Model\Entity\PageContent[] $page_contents
 * @property \App\Model\Entity\PageProduct[] $page_products
 * @property \App\Model\Entity\PageRoom[] $page_rooms
 */
class Menu extends Entity
{
    /**
     * Fields that can be mass assigned using newEntity() or patchEntity().
     *
     * Note that when '*' is set to true, this allows all unspecified fields to
     * be mass assigned. For security purposes, it is advised to set '*' to false
     * (or remove it), and explicitly make individual fields accessible as needed.
     *
     * @var array
     */
    protected $_accessible = [
        'name' => true,
        'description' => true,
        'parent_menu_id' => true,
        'status' => true,
        'slug' => true,
        'order_key' => true,
        'parent_menu' => true,
        'page_contents' => true,
        'page_products' => true,
        'page_rooms' => true
    ];
}
