<?php
namespace App\Model\Table;

use Cake\ORM\Query;
use Cake\ORM\RulesChecker;
use Cake\ORM\Table;
use Cake\Validation\Validator;


class UsersTable extends Table
{

    /**
     * Initialize method
     *
     * @param array $config The configuration for the Table.
     * @return void
     */
    public function initialize(array $config)
    {
        parent::initialize($config);

        $this->setTable('users');
        $this->setDisplayField('title');
        $this->setPrimaryKey('id');

       
    }

    /**
     * Default validation rules.
     *
     * @param \Cake\Validation\Validator $validator Validator instance.
     * @return \Cake\Validation\Validator
     */
    public function validationDefault(Validator $validator)
    {
        // $validator = new Validator();
        $validator
            ->integer('id')
            ->allowEmpty('id', 'create');
            
        $validator
        ->scalar('title')
        ->maxLength('title', 50)
        ->requirePresence('title', 'create')
        ->notEmptyString('title');
            
        $validator
        ->scalar('first_name')
        ->maxLength('first_name', 255)
        ->requirePresence('first_name', 'create')
        ->notEmptyString('first_name');

        // $validator->add('first_name', 'custom', [
        //     'rule' => 'first_name',
        //     'message' => 'The title is not valid'
        // ]);

        $validator
        ->scalar('last_name')
        ->maxLength('last_name', 255)
        ->requirePresence('last_name', 'create')
        ->notEmptyString('last_name');

        $validator
        ->scalar('image_path')
        ->maxLength('image_path', 255)
        ->requirePresence('image_path', 'create')
        ->notEmptyFile('image_path');

        $validator
        ->scalar('alternative_email')
        ->maxLength('alternative_email', 255)
        ->allowEmptyString('alternative_email');

        $validator
        ->scalar('gender')
        ->maxLength('gender', 10)
        ->requirePresence('gender', 'create')
        ->notEmptyString('gender');

        // $validator
        // ->dateTime('date_of_birth')
        // ->requirePresence('date_of_birth', 'create')
        // ->notEmptyDateTime('date_of_birth');

        $validator
            ->scalar('password')
            ->maxLength('password', 255)
            ->notEmptyString('password');

            $validator
            ->sameAs('passwordConfirm','password','not a mach');


            $validator
            ->scalar('token')
            ->maxLength('token', 255)
            ->allowEmptyString('token');

        $validator
            ->dateTime('token_created_at')
            ->allowEmptyDateTime('token_created_at');
            
            $validator
            ->email('email')
            ->requirePresence('email', 'create')
            ->notEmptyString('email');

            $validator
            ->scalar('phone_1')
            ->maxLength('phone_1', 20)
            ->requirePresence('phone_1', 'create')
            ->notEmptyString('phone_1');

        $validator
            ->scalar('phone_2')
            ->maxLength('phone_2', 20)
            ->requirePresence('phone_2', 'create')
            ->allowEmptyString('phone_2');



      
        // $validator
        //     ->scalar('firstName')
        //     ->maxLength('firstName', 100)
        //     ->notEmpty('firstName');

        // $validator
        //     ->scalar('lastName')
        //     ->maxLength('lastName', 100)
        //     ->notEmpty('lastName');

        //     $validator
        //     ->scalar('gender')
        //     ->maxLength('gender', 10)
        //     ->requirePresence('gender', 'create')
        //     ->notEmptyString('gender');

             
      

        // $validator
        //     ->scalar('password')
        //     ->maxLength('password', 255)
        //     ->notEmpty('password');

        // $validator
        //     ->email('email')
        //    ->requirePresence('email', 'create')
        //     ->notEmpty('email');

        // $validator
        //     ->scalar('phone')
        //     ->maxLength('phone', 100)
        //     ->notEmpty('phone');

        return $validator;
    }

    /**
     * Returns a rules checker object that will be used for validating
     * application integrity.
     *
     * @param \Cake\ORM\RulesChecker $rules The rules object to be modified.
     * @return \Cake\ORM\RulesChecker
     */
    // public function buildRules(RulesChecker $rules)
    // {
    //     $rules->add($rules->isUnique(['email']));

       
    //     return $rules;
    // }

  
}