<?php
/**
 * CakePHP(tm) : Rapid Development Framework (https://cakephp.org)
 * Copyright (c) Cake Software Foundation, Inc. (https://cakefoundation.org)
 *
 * Licensed under The MIT License
 * For full copyright and license information, please see the LICENSE.txt
 * Redistributions of files must retain the above copyright notice.
 *
 * @copyright     Copyright (c) Cake Software Foundation, Inc. (https://cakefoundation.org)
 * @link          https://cakephp.org CakePHP(tm) Project
 * @since         0.10.0
 * @license       https://opensource.org/licenses/mit-license.php MIT License
 * @var \App\View\AppView $this
 */

$siteDescription = $appSettings['SITE-NAME'];
?>
<!DOCTYPE html>
<html>

<head>
    <?= $this->Html->charset() ?>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>
        <?= $siteDescription ?>:
        <?= $this->fetch('title') ?>
    </title>
    <!-- </?= $this->Html->meta('icon') ?> -->
    <?= $this->Html->meta('favicon.ico','img/favicon.png',array('type' => 'icon'))?>

    <link href="https://fonts.googleapis.com/css?family=Raleway:400,700" rel="stylesheet">

    <!-- //?this link  is  fontawesome cdn  -->
    <script src="https://kit.fontawesome.com/a076d05399.js" crossorigin="anonymous"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  

    <!-- Latest compiled and minified CSS -->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css" rel="stylesheet">

    <link rel="stylesheet" href="https://www.w3schools.com/w3css/4/w3.css">

    <!-- Latest compiled JavaScript -->
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.bundle.min.js"></script>

 

    <?= $this->Html->css(['normalize.min', 'milligram.min','cake','responsive','footer','global','nav','banner','contact_form','home']) ?>
    <?= $this->Html->css('../assets/boxicons/css/boxicons.min.css') ?>
    <?= $this->Html->css('../css/bootstrap.min') ?>

    <?= $this->Html->script('../js/jquery-1.11.0.min') ?>

    <?= $this->fetch('meta') ?>
    <?= $this->fetch('css') ?>
    <?= $this->fetch('script') ?>


   
</head>

<body>

    <nav class="top-nav">
        <div class="top-nav-title">
            <?php echo $this->element(Cake\Core\Configure::read('Menus.main_menu', 'menus/main_menu3')); ?>
        </div>
    </nav>

    <main class="main">
        
            <?= $this->fetch('content') ?>
       
    </main>
    <footer>
        <!-- <//?php echo $this->element('footers/footer_sr'); ?> -->
        <?php echo $this->element('footers/footer5'); ?>
    </footer>
</body>

</html>